#ifndef ARROW_H
#define ARROW_H

#include "AReVi/Lib3D/object3D.h"
#include "AReVi/VRML/vrmlShape3D.h"
using namespace AReVi;

class Arrow : public Object3D {
public :
  AR_CLASS(Arrow)
  AR_CONSTRUCTOR(Arrow)

  virtual
  void
  linkTo(ArRef<Base3D> base);

  virtual
  ArRef<Base3D>
  getLinkedTo(void);

  virtual
  ArConstRef<Shape3D>
  getShape(void) const;

  virtual
  ArRef<Shape3D>
  accessShape(void);

protected :
  virtual
  void
  _onMotion(void);

  virtual
  void
  _onLinkMotionCB(const Base3D::MotionEvent& evt);

protected :
  ArRef<Base3D> _link;
  ArRef<VrmlShape3D> _sh;
  bool _motionFromLink;
};

#endif // ARROW_H
