#include "AReVi/arSystem.h"
#include "AReVi/activity.h"
#include "AReVi/Lib3D/viewer3D.h"
using namespace AReVi;

#include "arrow.h"
#include "gtkWindowPlugger.h"
#include "multiView.h"
#include "myObject3D.h"
#include "AReVi/Contrib/path.h"
#include "path3D.h"
#include "pathEditor.h"
#include "planeInteractor.h"

//----------------------------------------------------------------------------

ArRef<Scheduler>
simulationInit(void) {

  ArRef<Scheduler> sched = RealTimeScheduler::NEW(1e-3);

  ArRef<PathEditor> p = PathEditor::NEW();

 return(sched);
}

void registerPathEditorClasses(void);

int
main(int argc, char ** argv) {
  if(!gtk_init_check(&argc, &argv)) {
    cerr << "Cannot initialize GTK" << endl;
    return(-1);
  }
  ArSystem arevi(argc,argv);
  registerPathEditorClasses();
  ArSystem::loadPlugin("Imlib2ImageLoader");
  ArSystem::loadPlugin("MagickImageLoader");
  if(ArSystem::enterSimulation(&simulationInit)) {
    while(ArSystem::simulationStep()) {
      while(gtk_events_pending()) {
	gtk_main_iteration();
      }
    }
  }
  return 0;
}
