#include "myObject3D.h"

AR_CLASS_DEF(MyObject3D, Object3D)

MyObject3D::MyObject3D(ArCW& arCW)
: Object3D(arCW),
  _old(true),
  _translationCB(thisPtr()) {
}

MyObject3D::~MyObject3D(void) {
}

void
MyObject3D::_onMotion(void) {
  Object3D::_onMotion();

  double cx, cy, cz;
  getPosition(cx, cy, cz);

  double x, y, z;
  _old.getPosition(x, y, z);

  Vector3d d(cx - x, cy - y, cz - z);
  if(d.length() > 0.0 && !_translationCB.empty()) {
    TranslationEvent evt;
    _translationCB.fire(evt);
  }
}

