
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

struct Info
  {
  string show;
  string type;
  bool indirect;
  string enm;
  string init;
  };

Info t[]={
{ "Bool"     , "bool"               , false , "BOOL"      , "0"   },
{ "Char"     , "char"               , false , "CHAR"      , "0"   },
{ "UChar"    , "unsigned char"      , false , "UCHAR"     , "0"   },
{ "Short"    , "short"              , false , "SHORT"     , "0"   },
{ "UShort"   , "unsigned short"     , false , "USHORT"    , "0"   },
{ "Int"      , "int"                , false , "INT"       , "0"   },
{ "UInt"     , "unsigned int"       , false , "UINT"      , "0"   },
{ "LLong"    , "long long"          , false , "LLONG"     , "0"   },
{ "ULLong"   , "unsigned long long" , false , "ULLONG"    , "0"   },
{ "Float"    , "float"              , false , "FLOAT"     , "0.0" },
{ "Double"   , "double"             , false , "DOUBLE"    , "0.0" },
{ "String"   , "StlString"          , false , "STRING"    , ""    },
{ "Ref"      , "ArRef"              , true  , "REF"       , ""    },
{ "ConstRef" , "ArConstRef"         , true  , "CONST_REF" , ""    },
{ "Ptr"      , "ArPtr"              , true  , "PTR"       , ""    },
{ "ConstPtr" , "ArConstPtr"         , true  , "CONST_PTR" , ""    },
{ ""         , ""                   , false , ""          , ""    }};

const char * license=
"//-------------------------------------"
"---------------------------------------\n"
"// Copyright (C) 2002-2006  LI2/ENIB\n"
"//   Laboratoire d'Ingenierie Informatique (LI2)\n"
"//   Ecole Nationale d'Ingenieurs de Brest (ENIB)\n"
"//   CS 73862 - 29238 BREST Cedex 3 - France\n"
"//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr\n"
"//\n"
"// This software package is free software; you can redistribute it and/or\n"
"// modify it under the terms of the GNU Lesser General Public License as\n"
"// published by the Free Software Foundation; either version 2.1 of the\n"
"// License, or (at your option) any later version.\n"
"// This software package is distributed in the hope that it will be useful,\n"
"// but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
"// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser\n"
"// General Public License (file LICENSE-LGPL) for more details.\n"
"//-------------------------------------"
"---------------------------------------";

void
generateH(ostream & out)
{
out << "// LI2/ENIB - AReVi - Core services" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// file        : AReVi/arValue.h" << endl
    << "// author(s)   : F. Harrouet" << endl
    << license << endl
    << endl
    << "#ifndef AREVI_ARVALUE_H" << endl
    << "#define AREVI_ARVALUE_H 1" << endl
    << endl
    << "#include \"AReVi/arType.h\"" << endl
    << endl
    << "namespace AReVi {" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// Class ArValue" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << endl
    << "// Methods in class ``ArValue'' are NOT"
       " virtual because providing" << endl
    << "// a derived class has been made IMPOSSIBLE"
       " (to preserve consistency)" << endl
    << endl
    << "class ArValue : public ArObject" << endl
    << "{" << endl
    << "//-------- Type information -----------"
       "---------------------------------------" << endl
    << "public:" << endl
    << endl
    << "  AR_CLASS(ArValue)" << endl
    << endl
    << "//-------- Construction / Destruction -"
       "---------------------------------------" << endl
    << endl
    << "  AR_CONSTRUCTOR_1(ArValue," << endl
    << "                   ArConstRef<ArType>, type)" << endl
    << endl
    << "  AR_CONSTRUCTOR_2(ArValue," << endl
    << "                   ArType::DirectType, type," << endl
    << "                   unsigned int, dimension)" << endl
    << endl
    << "  AR_CONSTRUCTOR_3(ArValue," << endl
    << "                   ArType::IndirectType, type," << endl
    << "                   ArConstRef<ArClass>, cls," << endl
    << "                   unsigned int, dimension)" << endl
    << endl
    << "//-------- Value management -----------"
       "---------------------------------------" << endl
    << endl
    << "  inline" << endl
    << "  ArConstRef<ArType> // value type" << endl
    << "  getType(void) const;" << endl
    << endl;
for(unsigned int i=0;t[i].show.size();i++)
  {
  string type=t[i].type+(t[i].indirect ? "<ArObject>" : "");
  out << "  inline" << endl
      << "  bool // correct type" << endl
      << "  is" << t[i].show << "(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  const " << type << " & // null if bad type" << endl
      << "  get" << t[i].show << "(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  " << type << " & // null if bad type" << endl
      << "  access" << t[i].show << "(void);" << endl
      << endl;
  type="StlVector<"+type+(t[i].indirect ? " " : "")+">";
  out << "  inline" << endl
      << "  bool // correct type" << endl
      << "  is" << t[i].show << "V(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  const " << type << " & // null if bad type" << endl
      << "  get" << t[i].show << "V(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  " << type << " & // null if bad type" << endl
      << "  access" << t[i].show << "V(void);" << endl
      << endl;
  type="StlVector<"+type+" >";
  out << "  inline" << endl
      << "  bool // correct type" << endl
      << "  is" << t[i].show << "VV(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  const " << type << " & // null if bad type" << endl
      << "  get" << t[i].show << "VV(void) const;" << endl
      << endl;
  out << "  inline" << endl
      << "  " << type << " & // null if bad type" << endl
      << "  access" << t[i].show << "VV(void);" << endl
      << endl;
  }
out << "//-------- Member attributes ----------"
       "---------------------------------------" << endl
    << "private:" << endl
    << "  ArConstRef<ArType> _t;" << endl
    << "  void * _v;" << endl
    << "};" << endl
    << endl
    << "} // namespace AReVi" << endl
    << endl
    << "//-------- Inline source code ---------"
       "---------------------------------------" << endl
    << endl
    << "#include \"AReVi/arValue.Ci\"" << endl
    << endl
    << "#endif // AREVI_ARVALUE_H" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl;
}

void
generateCi(ostream & out)
{
out << "// LI2/ENIB - AReVi - Core services" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// file        : AReVi/arValue.Ci" << endl
    << "// author(s)   : F. Harrouet" << endl
    << license << endl
    << endl
    << "// Included from \"AReVi/arValue.h\"" << endl
    << endl
    << "namespace AReVi {" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// Class ArValue" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << endl
    << "//-------- Value management -----------"
       "---------------------------------------" << endl
    << endl
    << "inline" << endl
    << "ArConstRef<ArType> // value type" << endl
    << "ArValue::getType(void) const" << endl
    << "{" << endl
    << "return(_t);" << endl
    << "}" << endl
    << endl;
for(unsigned int i=0;t[i].show.size();i++)
  {
  string type=t[i].type+(t[i].indirect ? "<ArObject>" : "");
  string checkType=(t[i].indirect
                    ? "_t->getIndirectType()==ArType::IT_"
                    : "_t->getDirectType()==ArType::DT_");
  out << "inline" << endl
      << "bool // correct type" << endl
      << "ArValue::is" << t[i].show << "(void) const" << endl
      << "{" << endl
      << "return((_t->getDimension()==0)&&" << endl
      << "       (" << checkType << t[i].enm << "));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << "const " << type << " & // null if bad type" << endl
      << "ArValue::get" << t[i].show << "(void) const" << endl
      << "{" << endl
      << "return(is" << t[i].show << "()" << endl
      << "       ? *((const " << type << " *)_v)" << endl
      << "       : *((const " << type << " *)0));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << type << " & // null if bad type" << endl
      << "ArValue::access" << t[i].show << "(void)" << endl
      << "{" << endl
      << "return(is" << t[i].show << "()" << endl
      << "       ? *((" << type << " *)_v)" << endl
      << "       : *((" << type << " *)0));" << endl
      << "}" << endl
      << endl;
  type="StlVector<"+type+(t[i].indirect ? " " : "")+">";
  out << "inline" << endl
      << "bool // correct type" << endl
      << "ArValue::is" << t[i].show << "V(void) const" << endl
      << "{" << endl
      << "return((_t->getDimension()==1)&&" << endl
      << "       (" << checkType << t[i].enm << "));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << "const " << type << " & // null if bad type" << endl
      << "ArValue::get" << t[i].show << "V(void) const" << endl
      << "{" << endl
      << "return(is" << t[i].show << "V()" << endl
      << "       ? *((const " << type << " *)_v)" << endl
      << "       : *((const " << type << " *)0));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << type << " & // null if bad type" << endl
      << "ArValue::access" << t[i].show << "V(void)" << endl
      << "{" << endl
      << "return(is" << t[i].show << "V()" << endl
      << "       ? *((" << type << " *)_v)" << endl
      << "       : *((" << type << " *)0));" << endl
      << "}" << endl
      << endl;
  type="StlVector<"+type+" >";
  out << "inline" << endl
      << "bool // correct type" << endl
      << "ArValue::is" << t[i].show << "VV(void) const" << endl
      << "{" << endl
      << "return((_t->getDimension()==2)&&" << endl
      << "       (" << checkType << t[i].enm << "));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << "const " << type << " & // null if bad type" << endl
      << "ArValue::get" << t[i].show << "VV(void) const" << endl
      << "{" << endl
      << "return(is" << t[i].show << "VV()" << endl
      << "       ? *((const " << type << " *)_v)" << endl
      << "       : *((const " << type << " *)0));" << endl
      << "}" << endl
      << endl;
  out << "inline" << endl
      << type << " & // null if bad type" << endl
      << "ArValue::access" << t[i].show << "VV(void)" << endl
      << "{" << endl
      << "return(is" << t[i].show << "VV()" << endl
      << "       ? *((" << type << " *)_v)" << endl
      << "       : *((" << type << " *)0));" << endl
      << "}" << endl
      << endl;
  }
out << "} // namespace AReVi" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl;
}

void
generateCpp(ostream & out)
{
out << "// LI2/ENIB - AReVi - Core services" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// file        : AReVi/arValue.cpp" << endl
    << "// author(s)   : F. Harrouet" << endl
    << license << endl
    << endl
    << "#include \"AReVi/arValue.h\"" << endl
    << endl
    << "namespace AReVi {" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << "// Class ArValue" << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl
    << endl
    << "AR_CLASS_NOVOID_DEF(ArValue,ArObject)" << endl
    << endl
    << "//-------- Construction / Destruction -"
       "---------------------------------------" << endl
    << endl
    << "ArValue::ArValue(ArCW & arCW," << endl
    << "                 ArConstRef<ArType> type) // Protected" << endl
    << ": ArObject(arCW)," << endl
    << "  _t(type)," << endl
    << "  _v((void *)0)" << endl
    << "{" << endl
    << "// FIXME: optimize tests" << endl;
unsigned int i;
for(i=0;t[i].show.size();i++)
  {
  string type=t[i].type+(t[i].indirect ? "<ArObject>" : "");
  if(i) out << "else ";
  out << "if(is" << t[i].show << "())" << endl
      << "  {" << endl
      << "  _v=new " << type << "(" << t[i].init << ");" << endl
      << "  }" << endl;
  type="StlVector<"+type+(t[i].indirect ? " " : "")+">";
  out << "else if(is" << t[i].show << "V())" << endl
      << "  {" << endl
      << "  _v=new " << type << "();" << endl
      << "  }" << endl;
  type="StlVector<"+type+" >";
  out << "else if(is" << t[i].show << "VV())" << endl
      << "  {" << endl
      << "  _v=new " << type << "();" << endl
      << "  }" << endl;
  }
out << "}" << endl
    << endl
    << "ArValue::ArValue(ArCW & arCW," << endl
    << "                 ArType::DirectType type," << endl
    << "                 unsigned int dimension) // Protected" << endl
    << ": ArObject(arCW)," << endl
    << "  _t(new ArType(ArType::_CLS,type,dimension,ArType::PM_COPY)),"
    << endl
    << "  _v((void *)0)" << endl
    << "{" << endl
    << "ar_const_cast(_t)->setTransient(true);" << endl
    << "// FIXME: optimize tests" << endl;
bool first=true;
for(i=0;t[i].show.size();i++)
  {
  if(!t[i].indirect)
    {
    if(!first)
      {
      out << "else ";
      }
    else
      {
      first=false;
      }
    string type=t[i].type;
    out << "if(is" << t[i].show << "())" << endl
        << "  {" << endl
        << "  _v=new " << type << "(" << t[i].init << ");" << endl
        << "  }" << endl;
    type="StlVector<"+type+">";
    out << "else if(is" << t[i].show << "V())" << endl
        << "  {" << endl
        << "  _v=new " << type << "();" << endl
        << "  }" << endl;
    type="StlVector<"+type+" >";
    out << "else if(is" << t[i].show << "VV())" << endl
        << "  {" << endl
        << "  _v=new " << type << "();" << endl
        << "  }" << endl;
    }
  }
out << "}" << endl
    << endl
    << "ArValue::ArValue(ArCW & arCW," << endl
    << "                 ArType::IndirectType type," << endl
    << "                 ArConstRef<ArClass> cls," << endl
    << "                 unsigned int dimension) // Protected" << endl
    << ": ArObject(arCW)," << endl
    << "  _t(new ArType(ArType::_CLS,type,cls,dimension,ArType::PM_COPY)),"
    << endl
    << "  _v((void *)0)" << endl
    << "{" << endl
    << "ar_const_cast(_t)->setTransient(true);" << endl
    << "// FIXME: optimize tests" << endl;
first=true;
for(i=0;t[i].show.size();i++)
  {
  if(t[i].indirect)
    {
    if(!first)
      {
      out << "else ";
      }
    else
      {
      first=false;
      }
    string type=t[i].type+"<ArObject>";
    out << "if(is" << t[i].show << "())" << endl
        << "  {" << endl
        << "  _v=new " << type << "(" << t[i].init << ");" << endl
        << "  }" << endl;
    type="StlVector<"+type+" >";
    out << "else if(is" << t[i].show << "V())" << endl
        << "  {" << endl
        << "  _v=new " << type << "();" << endl
        << "  }" << endl;
    type="StlVector<"+type+" >";
    out << "else if(is" << t[i].show << "VV())" << endl
        << "  {" << endl
        << "  _v=new " << type << "();" << endl
        << "  }" << endl;
    }
  }
out << "}" << endl
    << endl
    << "ArValue::~ArValue(void) // Protected" << endl
    << "{" << endl
    << "// FIXME: optimize tests" << endl;
for(i=0;t[i].show.size();i++)
  {
  string type=t[i].type+(t[i].indirect ? "<ArObject>" : "");
  if(i) out << "else ";
  out << "if(is" << t[i].show << "())" << endl
      << "  {" << endl
      << "  delete (" << type << " *)_v;" << endl
      << "  }" << endl;
  type="StlVector<"+type+(t[i].indirect ? " " : "")+">";
  out << "else if(is" << t[i].show << "V())" << endl
      << "  {" << endl
      << "  delete (" << type << " *)_v;" << endl
      << "  }" << endl;
  type="StlVector<"+type+" >";
  out << "else if(is" << t[i].show << "VV())" << endl
      << "  {" << endl
      << "  delete (" << type << " *)_v;" << endl
      << "  }" << endl;
  }
out << "}" << endl
    << endl
    << "} // namespace AReVi" << endl
    << endl
    << "//-------------------------------------"
       "---------------------------------------" << endl;
}

int
main(void)
{
ofstream hOut("arValue.h");
generateH(hOut);
ofstream ciOut("arValue.Ci");
generateCi(ciOut);
ofstream cppOut("arValue.cpp");
generateCpp(cppOut);
return(0);
}

