// LI2/ENIB - AReVi-Contrib - 3D file loader/saver
//----------------------------------------------------------------------------
// file        : AReVi/Contrib/File3D/vrmlSaver.h
// author(s)   : C. Septseault
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_CONTRIB_FILE3D_VRMLSAVER_H
#define AREVI_CONTRIB_FILE3D_VRMLSAVER_H 1

#include "AReVi/arObject.h"
namespace AReVi
{
	class FDOStream;
	class Shape3D;
	class ShapePart3D;
	class Surface3D;
	class Material3D;
	class URLTexture;
	class Transform2D;
	

class VrmlSaver
{
	protected:
	friend class File3D;	
	void saveVrml(ArRef<FDOStream> stream,ArConstRef<Shape3D> shape);
	void saveVrmlSurface3D(ostream& stream,ArConstRef<ShapePart3D> shp);
	void saveVrmlMaterial(ostream& stream,ArConstRef<Material3D> material);
	void saveVrmlTexture(ostream& stream,ArConstRef<URLTexture> urlTexture);
	void saveVrmlTextureTransform(ostream& stream,ArConstRef<Transform2D> textureTransform);
	void saveVrmlGeometry(ostream& stream,ArConstRef<Surface3D> surface3D);
	void saveVrmlFaces(ostream& stream,const vector<Util3D::Face> & faces);
	void saveVrmlDbl3(ostream& stream,const vector<Util3D::Dbl3> & dbl3);
	void saveVrmlDbl2(ostream& stream,const vector<Util3D::Dbl2> & dbl2);
};


} // namespace AReVi

#endif // AREVI_CONTRIB_FILE3D_VRMLSAVER_H

//----------------------------------------------------------------------------
