// LI2/ENIB - AReVi-Contrib - ArMath ???
//----------------------------------------------------------------------------
// file        : AReVi/Contrib/arMath.h
// author(s)   : T. Jourdan
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_CONTRIB_ARMATH_H
#define AREVI_CONTRIB_ARMATH_H 1

#include "AReVi/Utils/math_priv.h"

#include <assert.h>
#include <iostream>
using namespace std;

const double ARMATH_PRECISION = 0.000000001;

#include "AReVi/Contrib/ArMath/point2D.h"
#include "AReVi/Contrib/ArMath/point3D.h"
#include "AReVi/Contrib/ArMath/vector2D.h"
#include "AReVi/Contrib/ArMath/vector3D.h"
#include "AReVi/Contrib/ArMath/vectorND.h"
#include "AReVi/Contrib/ArMath/line2D.h"
#include "AReVi/Contrib/ArMath/line3D.h"
#include "AReVi/Contrib/ArMath/plane.h"
#include "AReVi/Contrib/ArMath/matrix3x3.h"
#include "AReVi/Contrib/ArMath/matrix4x4.h"
#include "AReVi/Contrib/ArMath/quaternion.h"

namespace AReVi {

/** Values utilities */

inline double clamp(double v, double a, double b);

/**** collision with std::min std::max under IRIX
template <class T> inline
T
min(T a, T b);

template <class T> inline
T
max(T a, T b);
****/

inline double modulo(double a, double s);

/** Linear Interpolation */
inline double lerp(double a, double b, double p);

#include "AReVi/Contrib/ArMath/point2D.Ci"
#include "AReVi/Contrib/ArMath/point3D.Ci"
#include "AReVi/Contrib/ArMath/vector2D.Ci"
#include "AReVi/Contrib/ArMath/vector3D.Ci"
#include "AReVi/Contrib/ArMath/vectorND.Ci"
#include "AReVi/Contrib/ArMath/line2D.Ci"
#include "AReVi/Contrib/ArMath/line3D.Ci"
#include "AReVi/Contrib/ArMath/plane.Ci"
#include "AReVi/Contrib/ArMath/matrix3x3.Ci"
#include "AReVi/Contrib/ArMath/matrix4x4.Ci"
#include "AReVi/Contrib/ArMath/quaternion.Ci"
#include "AReVi/Contrib/ArMath/arMath.Ci"

} // namespace AReVi

#endif // AREVI_CONTRIB_ARMATH_H

//----------------------------------------------------------------------------
