// LI2/ENIB - AReVi - 3D services
//----------------------------------------------------------------------------
// file        : AReVi/Lib3D/embededWindow3D.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_LIB3D_EMBEDDEDWINDOW3D_H
#define AREVI_LIB3D_EMBEDDEDWINDOW3D_H 1

#include "AReVi/Lib3D/window3D.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class EmbeddedWindow3D
//----------------------------------------------------------------------------

class EmbeddedWindow3D : public Window3D
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(EmbeddedWindow3D)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_1(EmbeddedWindow3D,
                   int, externalWindowID)

//-------- Window ID ---------------------------------------------------------

  virtual
  int // platform-specific external window ID
  getExternalWindowID(void) const;

//-------- Member attributes -------------------------------------------------
protected:

  int _externalWindowID;
};

} // namespace AReVi

#endif // AREVI_LIB3D_EMBEDDEDWINDOW3D_H

//----------------------------------------------------------------------------
