// LI2/ENIB - AReVi - 3D services
//----------------------------------------------------------------------------
// file        : AReVi/Lib3D/textureCubeRenderer3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_LIB3D_TEXTURECUBERENDERER3D_H
#define AREVI_LIB3D_TEXTURECUBERENDERER3D_H 1

#include "AReVi/Lib3D/textureRenderer3D.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class TextureCubeRenderer3D
//----------------------------------------------------------------------------

class TextureCubeRenderer3D : public TextureRenderer3D
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(TextureCubeRenderer3D)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR(TextureCubeRenderer3D)

//-------- Rendering ---------------------------------------------------------

  virtual
  void
  render(void);

  virtual
  ArRef<RenderTexture> // created texture
  buildTexture(void);

  virtual
  void
  setRenderSize(unsigned int width,
                unsigned int height);

//-------- Forbidden operations ----------------------------------------------
protected:

  virtual
  void
  _postRender(void);

//-------- Member attributes -------------------------------------------------
protected:
  unsigned _currentRendererFace;
  LLW::AreaID _swapRenderArea;
};

} // namespace AReVi

#endif // AREVI_LIB3D_TEXTURECUBERENDERER3D_H

//----------------------------------------------------------------------------
