// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/allocator_priv.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_UTILS_ALLOCATOR_PRIV_H
#define AREVI_UTILS_ALLOCATOR_PRIV_H 1

#include <stdlib.h>
#include <string.h>

namespace AReVi {

//----------------------------------------------------------------------------
// Class Allocator
//----------------------------------------------------------------------------

class Allocator
{
public:
//-------- Memory management -------------------------------------------------

  inline static
  void *
  allocate(unsigned int size);

  inline static
  void
  deallocate(void * ptr);

  inline static
  void *
  reallocate(void * ptr,
             unsigned int newSize);

//-------- Forbidden operations ----------------------------------------------
private:

  inline static
  unsigned int
  _blockIndex(unsigned int size);

  inline static
  unsigned int
  _blockSize(unsigned int size);

  enum { _sizeOffset=8, _maxBlockSize=65536 };

//-------- Static attributes -------------------------------------------------
private:

  static void * _blockList[2048];
};

} // namespace AReVi

//-------- Inline source code ------------------------------------------------

#include "AReVi/Utils/allocator_priv.Ci"

#endif // AREVI_UTILS_ALLOCATOR_PRIV_H

//----------------------------------------------------------------------------
