// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/fdStream.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_UTILS_FDSTREAM_H
#define AREVI_UTILS_FDSTREAM_H 1

#include "AReVi/Utils/abstractStream.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class FDIStream
//----------------------------------------------------------------------------

class FDIStream : public AbstractIStream
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(FDIStream)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_2(FDIStream,
                   int, fileDescriptor,
                   bool, closeOnDestruction)

//-------- File descriptor ---------------------------------------------------

  virtual
  int // file descriptor
  getFileDescriptor(void) const;

  virtual
  bool // close file descriptor on destruction
  closeOnDestruction(void) const;

//-------- Forbidden operations ----------------------------------------------
protected:

  virtual
  int // >0: nb read   <=0: error
  _readBuffer(char * buffer,
              unsigned int size);

//-------- Member attributes -------------------------------------------------
protected:

  int _fd;
  bool _close;
};


//----------------------------------------------------------------------------
// Class FDOStream
//----------------------------------------------------------------------------

class FDOStream : public AbstractOStream
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(FDOStream)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_2(FDOStream,
                   int, fileDescriptor,
                   bool, closeOnDestruction)

//-------- File descriptor ---------------------------------------------------

  virtual
  int // file descriptor
  getFileDescriptor(void) const;

  virtual
  bool // close file descriptor on destruction
  closeOnDestruction(void) const;

//-------- Forbidden operations ----------------------------------------------
protected:

  virtual
  int // >0: nb written   -1: error
  _writeBuffer(const char * buffer,
               unsigned int size);

//-------- Member attributes -------------------------------------------------
protected:

  int _fd;
  bool _close;
};

} // namespace AReVi

#endif // AREVI_UTILS_FDSTREAM_H

//----------------------------------------------------------------------------
