// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/fileStream.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_UTILS_FILESTREAM_H
#define AREVI_UTILS_FILESTREAM_H 1

#include "AReVi/Utils/fdStream.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class FileIStream
//----------------------------------------------------------------------------

class FileIStream : public FDIStream
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(FileIStream)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_1(FileIStream,
                   const StlString &, fileName)

//-------- File informations -------------------------------------------------

  virtual
  const StlString & // file name
  getFileName(void) const;

  virtual
  unsigned int // file size
  getFileSize(void) const;

//-------- Member attributes -------------------------------------------------
protected:

  StlString _file;
};


//----------------------------------------------------------------------------
// Class FileOStream
//----------------------------------------------------------------------------

class FileOStream : public FDOStream
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(FileOStream)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_2(FileOStream,
                   const StlString &, fileName,
                   bool, append)

//-------- File informations -------------------------------------------------

  virtual
  const StlString & // file name
  getFileName(void) const;

  virtual
  bool // write at the end of the file
  append(void) const;

//-------- Member attributes -------------------------------------------------
protected:

  StlString _file;
  bool _append;
};

} // namespace AReVi

#endif // AREVI_UTILS_FILESTREAM_H

//----------------------------------------------------------------------------
