// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/joystick.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_UTILS_JOYSTICK_H
#define AREVI_UTILS_JOYSTICK_H 1

#include "AReVi/Utils/inputDevice.h"

namespace AReVi {

struct JoystickData;

//----------------------------------------------------------------------------
// Class Joystick
//----------------------------------------------------------------------------

class Joystick : public InputDevice
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(Joystick)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR_1(Joystick,
                   const StlString &, device)

//-------- Device management -------------------------------------------------

  virtual
  bool // success
  reset(const StlString & device);

  virtual
  void
  update(void);

//-------- Member attributes -------------------------------------------------
protected:

  JoystickData * _jsData;
};

} // namespace AReVi

#endif // AREVI_UTILS_JOYSTICK_H

//----------------------------------------------------------------------------
