// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/utilSound.h
// author(s)   : E. Cazeaux, B. Muguet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_UTILS_UTILSOUND_H
#define AREVI_UTILS_UTILSOUND_H 1

#include "AReVi/arObject.h"

namespace AReVi {

class MemoryBlock;

//----------------------------------------------------------------------------
// Class UtilSound (abstract)
//----------------------------------------------------------------------------

class UtilSound
{
public:
  enum SoundFormat { MONO8,MONO16,STEREO8,STEREO16 };

  static
  bool
  createWavFileFromSoundBuffer(StlString filename,
                               ArRef<MemoryBlock> soundBuffer,
                               int sampleRate,
                               short nbChannels,
                               short bitsPerSample);

  static
  bool
  createWavFileFromSoundBuffers(StlString filename,
                                StlList<ArRef<MemoryBlock> > soundBuffers,
                                int sampleRate,
                                short nbChannels,
                                short bitsPerSample);
};

} // namespace AReVi

#endif // AREVI_UTILS_UTILSOUND_H

//----------------------------------------------------------------------------
