// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/geometryNode_priv.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_VRML_GEOMETRYNODE_PRIV_H
#define AREVI_VRML_GEOMETRYNODE_PRIV_H 1

#include "AReVi/VRML/vrmlNode_priv.h"

namespace AReVi {

class ShapePart3D;
class MaterialNode;

//----------------------------------------------------------------------------
// Class GeometryNode
//----------------------------------------------------------------------------

class GeometryNode : public VrmlNode
{
//-------- Construction / Destruction ----------------------------------------
public:

  virtual
  ~GeometryNode(void);

//-------- Inspection --------------------------------------------------------

  virtual
  bool // is a geometry
  isGeometry(void) const;

  virtual
  bool // made of triangles
  isSurface(void) const;

//-------- Rendering ---------------------------------------------------------

  virtual
  ArRef<ShapePart3D> // built part
  buildPart(Util3D::Transform & initTransformOut) const=0;

  virtual
  void
  postRebuild(void);

  virtual
  void
  updatePart(ArRef<ShapePart3D> part,
             const MaterialNode * material) const=0;

//-------- Forbidden operations ----------------------------------------------
protected:

  GeometryNode(const StlString & nodeType,
               VrmlShape3D * shape);

private:

  GeometryNode(void); // no implementation

  GeometryNode(const GeometryNode & obj); // no implementation

  GeometryNode & // itself
  operator=(const GeometryNode & obj); // no implementation

//-------- Member attributes -------------------------------------------------
protected:

};

} // namespace AReVi

#endif // AREVI_VRML_GEOMETRYNODE_PRIV_H

//----------------------------------------------------------------------------
