// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/vrmlCylinderInteractor.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_VRML_VRMLCYLINDERINTERACTOR_H
#define AREVI_VRML_VRMLCYLINDERINTERACTOR_H 1

#include "AReVi/VRML/vrmlInteractor.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class VrmlCylinderInteractor
//----------------------------------------------------------------------------

class VrmlCylinderInteractor : public VrmlInteractor
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(VrmlCylinderInteractor)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR(VrmlCylinderInteractor)

//-------- Connection --------------------------------------------------------

  virtual
  bool // success
  connectToNode(ArRef<VrmlShape3D> shape,
                const StlString & nodeName,
                int occurence=-1);

  virtual
  bool // success
  connectTo(ArConstRef<VrmlInteractor> interactor);

//-------- Parameters --------------------------------------------------------

  virtual
  bool // success
  readBottomField(bool & bottomOut) const;

  virtual
  bool // success
  writeBottomField(bool bottom);

  virtual
  bool // success
  readRadiusField(double & radiusOut) const;

  virtual
  bool // success
  writeRadiusField(double radius);

  virtual
  bool // success
  readHeightField(double & heightOut) const;

  virtual
  bool // success
  writeHeightField(double height);

  virtual
  bool // success
  readSideField(bool & sideOut) const;

  virtual
  bool // success
  writeSideField(bool side);

  virtual
  bool // success
  readTopField(bool & topOut) const;

  virtual
  bool // success
  writeTopField(bool top);

  virtual
  bool // success
  readSolidField(bool & solidOut) const;

  virtual
  bool // success
  writeSolidField(bool solid);
};

} // namespace AReVi

#endif // AREVI_VRML_VRMLCYLINDERINTERACTOR_H

//----------------------------------------------------------------------------
