// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/vrmlGenericInteractor.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_VRML_VRMLGENERICINTERACTOR_H
#define AREVI_VRML_VRMLGENERICINTERACTOR_H 1

#include "AReVi/VRML/vrmlInteractor.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class VrmlGenericInteractor
//----------------------------------------------------------------------------

class VrmlGenericInteractor : public VrmlInteractor
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(VrmlGenericInteractor)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR(VrmlGenericInteractor)

//-------- Connection --------------------------------------------------------

  virtual
  bool // a shape/node is connected
  isConnected(void) const;

  virtual
  bool // success
  connectTo(ArConstRef<VrmlInteractor> interactor);

  virtual
  bool // success
  connectToShape(ArRef<VrmlShape3D> shape);

  virtual
  unsigned int // nb nodes in ``children'' field
  getNbChildren() const;

  virtual
  bool // success
  moveToChild(unsigned int childIndex);

  virtual
  void
  getChildFieldNames(StlVector<StlString> & childFieldNamesOut) const;

  virtual
  bool // success
  moveToField(const StlString & fieldName);
};

} // namespace AReVi

#endif // AREVI_VRML_VRMLGENERICINTERACTOR_H

//----------------------------------------------------------------------------
