// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/vrmlIndexedFaceSetInteractor.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_VRML_VRMLINDEXEDFACESETINTERACTOR_H
#define AREVI_VRML_VRMLINDEXEDFACESETINTERACTOR_H 1

#include "AReVi/VRML/vrmlInteractor.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class VrmlIndexedFaceSetInteractor
//----------------------------------------------------------------------------

class VrmlIndexedFaceSetInteractor : public VrmlInteractor
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(VrmlIndexedFaceSetInteractor)

//-------- Construction / Destruction ----------------------------------------

  AR_CONSTRUCTOR(VrmlIndexedFaceSetInteractor)

//-------- Connection --------------------------------------------------------

  virtual
  bool // success
  connectToNode(ArRef<VrmlShape3D> shape,
                const StlString & nodeName,
                int occurence=-1);

  virtual
  bool // success
  connectTo(ArConstRef<VrmlInteractor> interactor);

//-------- Parameters --------------------------------------------------------

  virtual
  bool // success
  readCcwField(bool & ccwOut) const;

  virtual
  bool // success
  writeCcwField(bool ccw);

  virtual
  bool // success
  readSolidField(bool & solidOut) const;

  virtual
  bool // success
  writeSolidField(bool solid);
};

} // namespace AReVi

#endif // AREVI_VRML_VRMLINDEXEDFACESETINTERACTOR_H

//----------------------------------------------------------------------------
