// LI2/ENIB - AReVi - Core services
//----------------------------------------------------------------------------
// file        : AReVi/arConstant.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_ARCONSTANT_H
#define AREVI_ARCONSTANT_H 1

#include "AReVi/arObject.h"

namespace AReVi {

class ArValue;

//----------------------------------------------------------------------------
// Class ArConstant
//----------------------------------------------------------------------------

// Methods in class ``ArConstant'' are NOT virtual because providing
// a derived class has been made IMPOSSIBLE (to preserve consistency)

class ArConstant : public ArObject
{
//-------- Type information --------------------------------------------------
public:

  AR_CLASS(ArConstant)

//-------- Inspection --------------------------------------------------------

  ArConstRef<ArClass> // class declaring this constant
  getDeclarationClass(void) const;

  const StlString & // declaration header file of this constant
  getDeclarationFile(void) const;

  unsigned int // declaration line number of this constant
  getDeclarationLine(void) const;

  const StlString & // name of this constant
  getName(void) const;

  ArConstRef<ArValue> // value of this constant
  getValue(void) const;

//-------- Forbidden operations ----------------------------------------------
private:

  friend class ArStubHelper;

  ArConstant(ArCW & arCW,
             ArConstRef<ArClass> declCls,
             const StlString & declFile,
             unsigned int declLine,
             const StlString & cstName,
             ArConstRef<ArValue> value);

//-------- Member attributes -------------------------------------------------
private:
  ArConstRef<ArClass> _declCls;
  StlString _declFile;
  unsigned int _declLine;
  StlString _cstName;
  ArConstRef<ArValue> _value;
};

} // namespace AReVi

#endif // AREVI_ARCONSTANT_H

//----------------------------------------------------------------------------
