// LI2/ENIB - AReVi - Core services
//----------------------------------------------------------------------------
// file        : AReVi/arStubHelper_priv.h
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVI_ARSTUBMAKER_H
#define AREVI_ARSTUBMAKER_H 1

#include "AReVi/arValue.h"
#include "AReVi/arMethod.h"
#include "AReVi/arConstant.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class ArStubHelper
//----------------------------------------------------------------------------

// This class is not intended to be used by AReVi users.
// Its only purpose is to allow the stub generator to fill in
// the ArClasses with ArMethods and ArConstants.

class ArStubHelper
{
public:

  static
  void
  initCls(const char * clsName,
          void (*mthFnct)(ArConstRef<ArClass>),
          void (*cstFnct)(ArConstRef<ArClass>));

  static
  void
  constant(ArConstRef<ArClass> cls,
           const char * declFile,
           unsigned int declLine,
           const char * cstName,
           ArConstRef<ArValue> v);

  static
  void
  method(ArMethod * & m,
         ArConstRef<ArClass> cls,
         const char * declFile,
         unsigned int declLine,
         const char * mthName,
         bool isStatic,
         bool isConst,
         ArMethod::Stub stub);

  static
  void
  result(ArMethod * & m,
         ArType::DirectType dType,
         unsigned int dimension,
         ArType::PassingMode pMode);

  static
  void
  result(ArMethod * & m,
         ArType::IndirectType iType,
         const char * clsName,
         unsigned int dimension,
         ArType::PassingMode pMode);

  static
  void
  arg(ArMethod * & m,
      const char * name,
      ArType::DirectType dType,
      unsigned int dimension,
      ArType::PassingMode pMode);

  static
  void
  arg(ArMethod * & m,
      const char * name,
      ArType::IndirectType iType,
      const char * clsName,
      unsigned int dimension,
      ArType::PassingMode pMode);
};

} // namespace AReVi

#endif // AREVI_ARSTUBMAKER_H

//----------------------------------------------------------------------------
