// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Controlers/nsCtrlTextureRenderer3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSCONTROLERTEXTURERENDERER3D_H
#define AREVINS_NSCONTROLERTEXTURERENDERER3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Controlers/nsCtrlRenderer3D.h"
#include "AReVi/Lib3D/textureRenderer3D.h"

namespace AReVi {
//----------------------------------------------------------------------------
// CLASS       : NSListenerTextureRenderer3D
//----------------------------------------------------------------------------

/*! \class NSListenerTextureRenderer3D
  * Network Service Event class
  */
class NSListenerTextureRenderer3D : public NSListenerRenderer3D
{
public:
  AR_UNSTUBBED AR_CLASS(NSListenerTextureRenderer3D)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSListenerTextureRenderer3D)

//---------------------------- Public methods --------------------------------
public:
  //! Controler will sign to all object events and will be able to transmit
  //! them. (getPendingEvents());
  virtual void
  init(ArRef<LocalDepService> service, ArRef<ArObject> object);

  //! Return events backup (eg : motion, setup change ...)
  virtual void
  getPendingEvents(StlList<ArRef<NSEvent> > &events);

//------------------------- Forbiden operations ------------------------------
protected:
  virtual void
  _onRenderCB(const TextureRenderer3D::RenderEvent &event);

//----------------------------- Attributes -----------------------------------
protected:
  ArPtr<TextureRenderer3D> _textureRenderer;
  bool _renderFlag;
};

//----------------------------------------------------------------------------
// CLASS       : NSInteractorTextureRenderer3D
//----------------------------------------------------------------------------

/*! \class NSInteractorTextureRenderer3D
  * Network Service Event class
  */
class NSInteractorTextureRenderer3D : public NSInteractorRenderer3D
{
public:
  AR_UNSTUBBED AR_CLASS(NSInteractorTextureRenderer3D)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSInteractorTextureRenderer3D)

//---------------------------- Public methods --------------------------------
public:
  //! Controler will sign to all object network events and will be able to
  //! affect remote object with.
  virtual void
  init(ArRef<RemoteDepService> service, ArRef<ArObject> object);

//------------------------- Forbiden operations ------------------------------
protected:
  virtual NSEvent::EventProcess
  _onRenderingSetupEvent(ArConstRef<NSEvent> event);

  virtual NSEvent::EventProcess
  _onRenderEvent(ArConstRef<NSEvent> event);

//----------------------------- Attributes -----------------------------------
protected:
  ArPtr<TextureRenderer3D> _textureRenderer;
};

} // end of namespace AReVi
#endif // end of AREVINS_NSCONTROLERTEXTURERENDERER3D_H
//---End-Of-File---------------------------------------------------------------
