// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventBase3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef NETWORKSERVICE_NSEVENTBASE3D_H
#define NETWORKSERVICE_NSEVENTBASE3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"
#include "AReVi/Lib3D/util3D_priv.h"

//----------------------------------------------------------------------------
// CLASS       : NSEventBase3DMotion
//----------------------------------------------------------------------------
namespace AReVi {

/*! \class NSEventBase3DMotion
  * Object3D on motion event
  */
class NSEventBase3DMotion : public NSEventRef
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventBase3DMotion)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventBase3DMotion)

//---------------------------- Public methods --------------------------------
public:
  //! Get Set base3D attrib
  const Util3D::Base &
  getBase(void) const;

  void
  setBase(const Util3D::Base &base);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  Util3D::Base _base;
};

} // end of namespace AReVi
#endif // end of NETWORKSERVICE_NSEVENTBASE3D_H
//---End-Of-File---------------------------------------------------------------
