// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventCylinder3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTCYLINDER3D_H
#define AREVINS_NSEVENTCYLINDER3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEventShapePart3D.h"

namespace AReVi {
class Cylinder3D;

//----------------------------------------------------------------------------
// CLASS       : NSEventCylinder3DGeometryRebuild
//----------------------------------------------------------------------------
/*! \class NSEventCylinder3DGeometryRebuild
  * BasicShape3D on postAppearanceRebuild event
  */
class NSEventCylinder3DGeometryRebuild : public NSEventShapePart3DGeometryRebuild
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventCylinder3DGeometryRebuild)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventCylinder3DGeometryRebuild)

  virtual void
  writeGeometry(ArConstRef<Cylinder3D> cylinder);

  virtual void
  readGeometry(ArRef<Cylinder3D> cylinder) const;

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

protected:
  double _radius;
  double _height;
  bool _side;
  bool _top;
  bool _bottom;
  bool _ccw;
  unsigned int _precision;
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTCYLINDER3D_H
//---End-Of-File---------------------------------------------------------------
