// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventDataSound3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTDATASOUND3D_H
#define AREVINS_NSEVENTDATASOUND3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"

namespace AReVi
{
  class DataSound3D;
  class MemoryBlock;
}

//----------------------------------------------------------------------------
// CLASS       : NSEventDataSound3DPushBuffer
//----------------------------------------------------------------------------
namespace AReVi {

/*! \class NSEventDataSound3DPushBuffer
  *
  */
class NSEventDataSound3DPushBuffer : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventDataSound3DPushBuffer)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventDataSound3DPushBuffer)

//---------------------------- Public methods --------------------------------
public:
  //! Read/Write sound parameters
  virtual bool
  readDataSound3D(ArRef<DataSound3D> sound) const;

  virtual void
  writeDataSound3D(unsigned int frequency,unsigned int format, ArConstRef<MemoryBlock> buffer);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  unsigned int _frequency;
  unsigned int _format;
  ArConstRef<MemoryBlock> _buffer;
};


/*! \class NSEventDataSound3DPopBuffer
  *
  */
class NSEventDataSound3DPopBuffer : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventDataSound3DPopBuffer)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventDataSound3DPopBuffer)
};


} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTDATASOUND3D_H
//---End-Of-File---------------------------------------------------------------
