// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventLight3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTLIGHT3D_H
#define AREVINS_NSEVENTLIGHT3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"

namespace AReVi
{
  class Light3D;
}

//----------------------------------------------------------------------------
// CLASS       : NSEventLight3DViewParameters
//----------------------------------------------------------------------------
namespace AReVi {

/*! \class NSEventLight3DViewParameters
  *
  */
class NSEventLight3DSetup : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventLight3DSetup)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventLight3DSetup)

//---------------------------- Public methods --------------------------------
public:
  //! Read/Write views parameters
  virtual void
  readLight3DSetup(ArRef<Light3D> renderer) const;

  virtual void
  writeLight3DSetup(ArConstRef<Light3D> renderer);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  bool _on;
  bool _directional;
  double _constantAtt;
  double _linearAtt;
  double _quadraticAtt;
  double _spotExponent;
  double _spotCutOff;
  double _color[3];
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTLIGHT3D_H
//---End-Of-File---------------------------------------------------------------
