// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventMesh3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTMESH3D_H
#define AREVINS_NSEVENTMESH3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEventShapePart3D.h"

namespace AReVi
{
  class Mesh3D;
  class MemoryBlock;
}

namespace AReVi {

//----------------------------------------------------------------------------
// CLASS       : NSEventMesh3DGeometryRebuild
//----------------------------------------------------------------------------
/*! \class NSEventMesh3DGeometryRebuild
  * BasicShape3D on postAppearanceRebuild event
  */
class NSEventMesh3DGeometryRebuild : public NSEventShapePart3DGeometryRebuild
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventMesh3DGeometryRebuild)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventMesh3DGeometryRebuild)

  virtual void
  writeGeometry(ArConstRef<Mesh3D> mesh);

  virtual void
  readGeometry(ArRef<Mesh3D> mesh) const;

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

protected:
  ArRef<MemoryBlock> _meshData;
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTMESH3D_H
//---End-Of-File---------------------------------------------------------------
