// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventRenderTexture.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTRENDERTEXTURE_H
#define AREVINS_NSEVENTRENDERTEXTURE_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"

namespace AReVi
{
  class RenderTexture;
}

namespace AReVi {
//----------------------------------------------------------------------------
// CLASS       : NSEventRenderTextureSetup
//----------------------------------------------------------------------------
/*! \class NSEventRenderTextureSetup
  * RenderTexture on setup event (blending/alpha change)
  */
class NSEventRenderTextureSetup : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventRenderTextureSetup)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventRenderTextureSetup)

//---------------------------- Public methods --------------------------------
public:
  //! Read/Write data parameters
  virtual void
  readRenderTexture(ArRef<RenderTexture> renderTexture) const;

  virtual void
  writeRenderTexture(ArConstRef<RenderTexture> renderTexture);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  bool _needsBlending,_needsAlphaTest;
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTRENDERTEXTURE_H
//---End-Of-File---------------------------------------------------------------
