// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventShape3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTSHAPE3D_H
#define AREVINS_NSEVENTSHAPE3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEventObjectRef.h"
#include "AReVi/Lib3D/util3D_priv.h"

namespace AReVi {

//----------------------------------------------------------------------------
// CLASS       : NSEventTransform3D
//----------------------------------------------------------------------------
/*! \class NSEventTransform3D
  * On Transform3D event
  */
class NSEventTransform3D : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventTransform3D)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventTransform3D)

  //! Get Set Transform3D attrib
  const Util3D::Transform &
  getTransform(void) const;

  void
  setTransform(const Util3D::Transform &tranform);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);
//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  Util3D::Transform _transform;
};

//----------------------------------------------------------------------------
// CLASS       : NSEventShapePart3DList
//----------------------------------------------------------------------------
/*! \class NSEventShapePart3DList
  * Event that content a vector of shapePart3D
  */
class NSEventShapePart3DList : public NSEventArRefList
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventShapePart3DList)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventShapePart3DList)

  //! addRef => surdefinition make sure that ref is a ShapePart3D ref!
  virtual void
  addRef(ArConstRef<ArObject> ref);
};


} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTSHAPE3D_H
//---End-Of-File---------------------------------------------------------------
