// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventSound3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTSOUND3D_H
#define AREVINS_NSEVENTSOUND3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"

namespace AReVi
{
  class Sound3D;
}

//----------------------------------------------------------------------------
// CLASS       : NSEventSound3DViewParameters
//----------------------------------------------------------------------------
namespace AReVi {

/*! \class NSEventSound3DViewParameters
  *
  */
class NSEventSound3DSetup : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventSound3DSetup)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventSound3DSetup)

//---------------------------- Public methods --------------------------------
public:
  // Get/Set URL name => check existance!
  /*const StlString &
  getURL(void) const;
*/
  //! Read/Write sound parameters
  virtual bool
  readSound3D(ArRef<Sound3D> sound/*,const  StlString &localURL*/) const;

  virtual void
  writeSound3D(ArConstRef<Sound3D> sound);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  //StlString _url;
  bool _repeat;
  bool _directional;
  bool _attenuated;

  double _gain;
  double _pitch;
  double _minDistance;
  double _maxDistance;
  double _innerAngle;
  double _outerAngle;
  double _outerGain;
};


/*! \class NSEventSound3DControl
  *
  */
class NSEventSound3DControl : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventSound3DControl)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventSound3DControl)

//---------------------------- Public methods --------------------------------
public:
  //! Read/Write sound controls
  virtual void
  readSound3D(ArRef<Sound3D> sound) const;

  virtual void
  writeSound3D(ArConstRef<Sound3D> sound);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

protected:
  bool _paused;
  bool _stopped;
  bool _playMode;
};


} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTSOUND3D_H
//---End-Of-File---------------------------------------------------------------
