// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventSurface3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTSURFACE3D_H
#define AREVINS_NSEVENTSURFACE3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEventShapePart3D.h"
#include "AReViNS/remoteDepService.h"
#include "AReVi/Lib3D/util3D_priv.h"

namespace AReVi
{
  class Material3D;
  class Surface3D;
  class Transform2D;
  class Texture;
}

namespace AReVi {

//----------------------------------------------------------------------------
// CLASS       : NSEventSurface3DAppearanceRebuild
//----------------------------------------------------------------------------
/*! \class NSEventSurface3DAppearanceRebuild
  * BasicShape3D on postAppearanceRebuild event
  */
class NSEventSurface3DAppearanceRebuild : public NSEventShapePart3DAppearanceRebuild
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventSurface3DAppearanceRebuild)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventSurface3DAppearanceRebuild)

  virtual void
  writeAppearance(ArConstRef<Surface3D> surface);

  virtual void
  readAppearance(ArRef<Surface3D> surfaceOut,
                 ArRef<RemoteDepService> depService) const;

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

protected:
  ArRef<Material3D> _material;
  bool _doubleSided;
  RemoteRef  _refTexture;
  RemoteRef  _refTexture2;
  RemoteRef  _refTexture3;
  RemoteRef  _refTexture4;
  ArRef<Transform2D> _texTransform;
  ArRef<Transform2D> _texTransform2;
  ArRef<Transform2D> _texTransform3;
  ArRef<Transform2D> _texTransform4;

  bool _repeatX,_repeatY,_cubeMapReflect;
  bool _repeatX2,_repeatY2,_cubeMapReflect2;
  bool _repeatX3,_repeatY3,_cubeMapReflect3;
  bool _repeatX4,_repeatY4,_cubeMapReflect4;
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTSURFACE3D_H
//---End-Of-File---------------------------------------------------------------
