// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventTextureRenderer3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTTEXTURERENDERER3D_H
#define AREVINS_NSEVENTTEXTURERENDERER3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEventRenderer3D.h"

//----------------------------------------------------------------------------
// CLASS       : NSEventTextureRenderer3DViewParameters
//----------------------------------------------------------------------------
namespace AReVi {
class TextureRenderer3D;

/*! \class NSEventTextureRenderer3DRenderingSetup
  *
  */
class NSEventTextureRenderer3DRenderingSetup : public NSEventRenderer3DRenderingSetup
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventTextureRenderer3DRenderingSetup)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventTextureRenderer3DRenderingSetup)

//---------------------------- Public methods --------------------------------
public:
  //! Set Size
  virtual void
  writeTextureRenderer3D(ArConstRef<TextureRenderer3D> textureRenderer);

  virtual void
  readTextureRenderer3D(ArRef<TextureRenderer3D> textureRenderer) const;

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  unsigned int _width,_height;
  bool _autoRender;
};

//----------------------------------------------------------------------------
// CLASS       : NSEventTextureRenderer3DRender
//----------------------------------------------------------------------------
/*! \class NSEventTextureRenderer3DRender
  *  Inform that Renderer must render...
  */
class NSEventTextureRenderer3DRender : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventTextureRenderer3DRender)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventTextureRenderer3DRender)
};

} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTTEXTURERENDERER3D_H
//---End-Of-File---------------------------------------------------------------
