// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventViewer3D.h
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#ifndef AREVINS_NSEVENTVIEWER3D_H
#define AREVINS_NSEVENTVIEWER3D_H 1

//--- Imported classes -------------------------------------------------------
#include "AReViNS/Events/nsEvent.h"
#include "AReVi/Lib3D/util3D_priv.h"

//----------------------------------------------------------------------------
// CLASS       : NSEventObject3DMotion
//----------------------------------------------------------------------------
namespace AReVi {
class Viewer3D;

/*! \class NSEventViewer3DListener
  *
  */
class NSEventViewer3DListener : public NSEventArRef
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventViewer3DListener)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventViewer3DListener)

//---------------------------- Public methods --------------------------------
public:
};

/*! \class NSEventViewer3DAppearance
  *
  */
class NSEventViewer3DAppearance : public NSEvent
{
public:
  AR_UNSTUBBED AR_CLASS(NSEventViewer3DAppearance)
//---------------------- Constructors / Destructor ---------------------------
  AR_CONSTRUCTOR(NSEventViewer3DAppearance)

//---------------------------- Public methods --------------------------------
public:
  //! Read/Write Viewer setup
  virtual void
  readViewerAppearance(ArRef<Viewer3D> viewer) const;

  virtual void
  writeViewerAppearance(ArConstRef<Viewer3D> viewer);

//-------------------------- Stream operations -------------------------------
  virtual void
  writeToStream(ArRef<AbstractOStream> output) const;

  virtual bool // success
  readFromStream(ArRef<AbstractIStream> input);

//------------------------- Forbiden operations ------------------------------
protected:
//----------------------------- Attributes -----------------------------------
  StlString _title;
  bool _decoration;
};


} // end of namespace AReVi
#endif // end of AREVINS_NSEVENTOBJECT3DMOTION_H
//---End-Of-File---------------------------------------------------------------
