// LI2/ENIB - AReVi-Contrib - Lua bindings
//----------------------------------------------------------------------------
// file        : AReVi/Contrib/arLua.cpp
// author(s)   : D. Herviou
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/arObject.h"
#include "AReVi/arSystem.h"
#include "AReVi/arType.h"
#include "AReVi/Contrib/arLua.h"

#include "AReVi/Contrib/arevi_lua_bindings.h"

#include <stdarg.h>

namespace AReVi{


bool Lua::_initSuccess=false;

void* (* Lua::_arlua_lua_open) (void)   = NULL ;
void* (* Lua::_arlua_lua_newstate) (Lua::lua_Allocator alloc , void* ud)   = NULL ;
void (* Lua::_arlua_lua_close)(void* L) = NULL ;

  /**< opening function */
int (* Lua::_arlua_luaopen_base)   (void* L) = NULL ;
int (* Lua::_arlua_luaopen_table)  (void* L) = NULL ;
int (* Lua::_arlua_luaopen_io)     (void* L) = NULL ;
int (* Lua::_arlua_luaopen_string) (void* L) = NULL ;
int (* Lua::_arlua_luaopen_math)   (void* L) = NULL ;
  //int (* Lua::_arlua_luaopen_loadlib)(void* L) = NULL ;
int (* Lua::_arlua_luaopen_debug)  (void* L) = NULL ;


  /**< execution stack */
void (* Lua::_arlua_lua_call)  (void* L, int nargs        , int nresults)              = NULL ;
int  (* Lua::_arlua_lua_pcall) (void* L, int nargs        , int nresults, int errfunc) = NULL ;
int  (* Lua::_arlua_lua_cpcall)(void* L, int(*func)(void*), void *ud)                  = NULL ;

  /**< error */
int  (* Lua::_arlua_lua_error)  (void* L         ) =  NULL ;
void (* Lua::_arlua_lua_concat) (void* L, int n  ) =  NULL ;

  /**< divers */
void (* Lua::_arlua_lua_getglobal)   (void* L,const char* s) =  NULL ;
void (* Lua::_arlua_lua_getfield)    (void* L,int index, const char* s) =  NULL ;
void (* Lua::_arlua_lua_setglobal)   (void* L,const char* s) =  NULL ;
void (* Lua::_arlua_lua_getregistry) (void* L              ) =  NULL ;


  /**< auxiliar library */
#ifdef LUA_JIT
  int (* Lua::_arlua_luaopen_jit     ) (void *L) = NULL;
#endif
void (* Lua::_arlua_luaL_openlib     ) (void* L, const char* libname,const void *l,int nup)    = NULL ;
void (* Lua::_arlua_luaL_openlibs    ) (void* L)    = NULL ;

int  (* Lua::_arlua_luaL_loadfile    ) (void* L, const char *filename)                         = NULL ;
int  (* Lua::_arlua_luaL_loadbuffer  ) (void* L, const char *buff,size_t sz, const char *name) = NULL ;

int  (* Lua::_arlua_luaL_dofile       ) (void* L, const char* filename)                         = NULL ;
int  (* Lua::_arlua_luaL_dostring     ) (void* L, const char* str)                              = NULL ;

// int  (* Lua::_arlua_lua_dobuffer     ) (void* L, const char* buff,size_t sz, const char* n)    = NULL ;
int  (* Lua::_arlua_luaL_newmetatable) (void* L, const char* name)                             = NULL ;
void (* Lua::_arlua_luaL_getmetatable) (void* L, const char* name)                             = NULL ;
int  (* Lua::_arlua_luaL_error       ) (void *L, const char *fmt, ...)                         = NULL ;


  /**< table manipulation */
void (* Lua::_arlua_lua_setmetatable) (void* L, int index)        = NULL ;
void (* Lua::_arlua_lua_newtable    ) (void* L)                   = NULL ;
void (* Lua::_arlua_lua_createtable ) (void* L,int narr, int nrec)= NULL ;
void (* Lua::_arlua_lua_gettable    ) (void* L,int index)         = NULL ;
void (* Lua::_arlua_lua_settable    ) (void* L,int index)         = NULL ;
void (* Lua::_arlua_lua_rawget      ) (void* L, int idx)          = NULL ;
void (* Lua::_arlua_lua_rawgeti     ) (void* L, int idx, int n)   = NULL ;
void (* Lua::_arlua_lua_rawset      ) (void* L, int idx)          = NULL ;
void (* Lua::_arlua_lua_rawseti     ) (void* L, int idx, int n)   = NULL ;
int  (* Lua::_arlua_lua_next        ) (void* L, int idx)          = NULL;

  /**< pushing element on stack */
void (* Lua::_arlua_lua_pushnil    ) (void* L)                              = NULL ;
void (* Lua::_arlua_lua_pushboolean) (void* L, int b)                       = NULL ;
void (* Lua::_arlua_lua_pushnumber ) (void* L, double n)                    = NULL ;
void (* Lua::_arlua_lua_pushlstring) (void* L,const char *s, size_t length) = NULL ;

void  (* Lua::_arlua_lua_pushstring       ) (void* L, const char *s)          = NULL ;
void  (* Lua::_arlua_lua_pushliteral      ) (void* L, const char *s)          = NULL ;
void  (* Lua::_arlua_lua_pushlightuserdata) (void* L, void* data)             = NULL ;
void  (* Lua::_arlua_lua_pushcfunction    ) (void* L, int(*cfuntion)(void*) ) = NULL ;
void* (* Lua::_arlua_lua_newuserdata      ) (void* L, int nBytes)             = NULL ;

  /**< query stack */
int             (* Lua::_arlua_lua_toboolean  ) (void* L, int index) = NULL ;
double          (* Lua::_arlua_lua_tonumber   ) (void* L, int index) = NULL ;
const char*     (* Lua::_arlua_lua_tostring   ) (void* L, int index) = NULL ;
void*           (* Lua::_arlua_lua_touserdata ) (void* L, int index) = NULL ;
size_t          (* Lua::_arlua_lua_strlen     ) (void* L, int index) = NULL ;
arlua_CFunction (* Lua::_arlua_lua_tocfunction) (void* L, int index) = NULL ;


  /**< testing element */
int (* Lua::_arlua_lua_isnumber       ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_iscfunction    ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isfunction     ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isuserdata     ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_islightuserdata) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isstring       ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isboolean      ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_istable        ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isnil          ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isnone         ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_isnoneornil    ) (void* L, int index) = NULL ;
int (* Lua::_arlua_lua_type           ) (void* L, int index) = NULL ;


  /**< stack manipulation */
int  (* Lua::_arlua_lua_gettop     ) (void* L)             = NULL ;
void (* Lua::_arlua_lua_settop     ) (void* L, int index)  = NULL ;
void (* Lua::_arlua_lua_pop        ) (void* L, int index)  = NULL ;
void (* Lua::_arlua_lua_pushvalue  ) (void* L, int index)  = NULL ;
void (* Lua::_arlua_lua_remove     ) (void* L, int index)  = NULL ;
void (* Lua::_arlua_lua_insert     ) (void* L, int index)  = NULL ;
void (* Lua::_arlua_lua_replace    ) (void* L, int index)  = NULL ;
int  (* Lua::_arlua_lua_checkstack ) (void* L, int sz)     = NULL ;


  /**< garbage manipulation */
void (* Lua::_arlua_luaC_collectgarbage ) (void* L)               = NULL ;
int  (* Lua::_arlua_lua_getgcthreshold  ) (void* L)               = NULL ;
void (* Lua::_arlua_lua_setgcthreshold  ) (void* L,int threshold) = NULL ;
int  (* Lua::_arlua_lua_gc              ) (void* L,int what, int data) = NULL ;


AR_CLASS_DEF(Lua,ArObject)

Lua::Lua(ArCW& arCW):
ArObject(arCW){
}

Lua::~Lua(){
}

  /**<  lua basic function */
void*   Lua::lua_open(void){
  if(_initSuccess){
    return (void*) _arlua_lua_open();
  }
  else{
    cerr<<"Need to initialize plugin LuaWrapper to use methods"<<endl;
    return NULL;
  }

}

void* Lua::lua_newstate(Lua::lua_Allocator allocator, void* ud){
  if(_initSuccess){
    return (void*) _arlua_lua_newstate(allocator,ud);
  }
  else{
    cerr<<"Need to initialize plugin LuaWrapper to use methods"<<endl;
    return NULL;
  }

}


void    Lua::lua_close(void* L){
  if(_initSuccess){
    _arlua_lua_close(L);
  }
  else{
    return ;
  }
}

   /**< opening function */
int  Lua::luaopen_base(void* L){
  if(_initSuccess){
    return _arlua_luaopen_base(L);
  }
  else{
    return 0;
  }
}
int  Lua::luaopen_table(void* L){
  if(_initSuccess){
    return _arlua_luaopen_table(L);
  }
  else{
    return 0;
  }
}

int  Lua::luaopen_io(void* L){
  if(_initSuccess){
    return _arlua_luaopen_io(L);
  }
  else{
    return 0;
  }
}
int  Lua::luaopen_string(void* L){
  if(_initSuccess){
    return _arlua_luaopen_string(L);
  }
  else{
    return 0;
  }
}
int  Lua::luaopen_math(void* L){
  if(_initSuccess){
    return _arlua_luaopen_math(L);
  }
  else{
    return 0;
  }
}

// int  Lua::luaopen_loadlib(void* L){
//   if(_initSuccess){
//     return _arlua_luaopen_loadlib(L);
//   }
//   else{
//     return 0;
//   }
// }

int  Lua::luaopen_debug(void* L){
  if(_initSuccess){
    return _arlua_luaopen_debug(L);
  }
  else{
    return 0;
  }
}


  /**< execution stack */
void  Lua::lua_call (void* L, int nargs, int nresults){
  if(_initSuccess){
    _arlua_lua_call(L,nargs,nresults);
  }
  else{
    return ;
  }
}

int  Lua::lua_pcall (void* L, int nargs, int nresults, int errfunc){
  if(_initSuccess){
    return _arlua_lua_pcall (L, nargs,  nresults,  errfunc);
  }
  else{
    return 0;
  }
}
int  Lua::lua_cpcall (void* L, int(*func)(void*), void *ud){
  if(_initSuccess){
    return _arlua_lua_cpcall (L,func,ud);
  }
  else{
    return 0;
  }
}

  /**< error */
int  Lua::lua_error (void* L){
  if(_initSuccess){
    return _arlua_lua_error(L);
  }
  else{
    return 0;
  }
}

void  Lua::lua_concat (void* L, int n){
  if(_initSuccess){
    _arlua_lua_concat(L,n);
  }
  else{
    return;
  }
}

  /**< divers */
void  Lua::lua_getglobal(void* L,const char* s){
  if(_initSuccess){
    _arlua_lua_getglobal(L,s);
  }
  else{
    return;
  }
}
void  Lua::lua_getfield(void* L,int index, const char* s){
  if(_initSuccess){
    _arlua_lua_getfield(L,index,s);
  }
  else{
    return;
  }
}

void  Lua::lua_setglobal(void* L,const char* s){
  if(_initSuccess){
    _arlua_lua_setglobal(L,s);
  }
  else{
    return;
  }
}
void  Lua::lua_getregistry(void* L){
  if(_initSuccess){
    _arlua_lua_getregistry(L);
  }
  else{
    return;
  }
}

  /**< auxiliar library */
void  Lua::luaL_openlib(void* L,
			const char* libname,
			const void *l,
			int nup){
  if(_initSuccess){
    _arlua_luaL_openlib(L,libname,l,nup);
  }
  else{
    return ;
  }
}

void  Lua::luaL_openlibs(void* L){
   if(_initSuccess){
     _arlua_luaL_openlibs(L);
  }
  else{
    return ;
  }
}

#ifdef LUA_JIT
int Lua::luaopen_jit(void *L){
  if(_initSuccess){
    return _arlua_luaopen_jit(L);
  }
  return 0;
}

#endif

int Lua::luaL_loadfile (void* L, const char *filename){
  if(_initSuccess){
     return _arlua_luaL_loadfile(L,filename);
  }
  else{
    return 0;
  }
}
int Lua::luaL_loadbuffer (void* L, const char *buff,
			  size_t sz,
			  const char *name){
  if(_initSuccess){
    return _arlua_luaL_loadbuffer (L,buff,sz,name);
  }
  else{
    return 0;
  }
}

int Lua::luaL_error(void* L, const char *fmt,...){
  if(_initSuccess){
    va_list argp;
    va_start(argp,fmt);
    return _arlua_luaL_error (L,fmt,argp);
  }
  else{
    return 0;
  }
}


int Lua::luaL_dofile(void* L, const char* filename){
  if(_initSuccess){
    return _arlua_luaL_dofile(L,filename);
  }
  else{
    return 0;
  }
}
int Lua::luaL_dostring(void* L, const char* str){
  if(_initSuccess){
    return _arlua_luaL_dostring(L,str);
  }
  else{
    return 0;
  }
}


int Lua::luaL_newmetatable(void* L, const char* name){
  if(_initSuccess){
    return _arlua_luaL_newmetatable(L,name);
  }
  else{
    return 0;
  }
}
void Lua::luaL_getmetatable(void* L, const char* name){
  if(_initSuccess){
    _arlua_luaL_getmetatable(L,name);
  }
  else{
    return ;
  }
}

  /**< table manipulation*/
void  Lua::lua_setmetatable(void* L, int index){
  if(_initSuccess){
    _arlua_lua_setmetatable(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_newtable(void* L){
  if(_initSuccess){
    _arlua_lua_newtable(L);
  }
  else{
    return ;
  }
}

void  Lua::lua_createtable(void* L, int narr, int nrec){
  if(_initSuccess){
    _arlua_lua_createtable(L,narr,nrec);
  }
  else{
    return ;
  }
}

void  Lua::lua_gettable(void* L,int index){
  if(_initSuccess){
    _arlua_lua_gettable(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_settable(void* L,int index){
  if(_initSuccess){
    _arlua_lua_settable(L,index);
  }
  else{
    return ;
  }
}

void  Lua::lua_rawget(void* L, int idx){
  if(_initSuccess){
    _arlua_lua_rawget(L,idx);
  }
  else{
    return ;
  }
}
void  Lua::lua_rawgeti(void* L, int idx, int n){
  if(_initSuccess){
    _arlua_lua_rawgeti(L,idx,n);
  }
  else{
    return ;
  }
}

void  Lua::lua_rawset(void* L, int idx){
  if(_initSuccess){
    _arlua_lua_rawset(L,idx);
  }
  else{
    return ;
  }
}
void  Lua::lua_rawseti(void* L, int idx, int n){
  if(_initSuccess){
    _arlua_lua_rawseti(L,idx,n);
  }
  else{
    return ;
  }
}

int Lua::lua_next(void* L, int idx){
  if(_initSuccess){
    return _arlua_lua_next(L,idx);
  }else{
    return 0;
  }

}


  /**< pushing element on stack */
void  Lua::lua_pushnil(void* L){
  if(_initSuccess){
       _arlua_lua_pushnil(L);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushboolean(void* L, int b){
  if(_initSuccess){
       _arlua_lua_pushboolean(L,b);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushnumber(void* L , double n){
  if(_initSuccess){
       _arlua_lua_pushnumber(L,n);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushlstring(void* L,
			   const char *s,
			   size_t length){
  if(_initSuccess){
    _arlua_lua_pushlstring(L,s,length);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushstring (void* L, const char *s){
  if(_initSuccess){
    _arlua_lua_pushstring(L,s);
  }
  else{
    return;
  }
}
void  Lua::lua_pushliteral (void* L, const char *s){
  if(_initSuccess){
    _arlua_lua_pushliteral(L,s);
  }
  else{
    return;
  }
}
void  Lua::lua_pushlightuserdata(void* L, void* data){
  if(_initSuccess){
    _arlua_lua_pushlightuserdata(L,data);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushcfunction(void* L, int(*cfunction)(void*) ){
  if(_initSuccess){
    _arlua_lua_pushcfunction(L,cfunction);
  }
  else{
    return ;
  }
}
void*  Lua::lua_newuserdata(void* L, int nBytes){
  if(_initSuccess){
    return _arlua_lua_newuserdata(L,nBytes);
  }
  else{
    return NULL;
  }
}

  /**< query stack */
int  Lua::lua_toboolean(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_toboolean(L,index);
  }
  else{
    return 0;
  }
}
double  Lua::lua_tonumber(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_tonumber(L,index);
  }
  else{
    return 0;
  }
}
const char*  Lua::lua_tostring(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_tostring(L,index);
  }
  else{
    return NULL;
  }
}
void*  Lua::lua_touserdata(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_touserdata(L,index);
  }
  else{
    return NULL;
  }
}
size_t  Lua::lua_strlen(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_strlen(L,index);
  }
  else{
    return 0;
  }
}
arlua_CFunction  Lua::lua_tocfunction(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_tocfunction(L,index);
  }
  else{
    return NULL;
  }
}

  /**< testing element */
int  Lua::lua_isnumber(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isnumber(L,index);
  }
  else{
    return 0;
  }
}
int  Lua::lua_iscfunction(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_iscfunction(L,index);
  }
  else{
    return 0;
  }
}
int  Lua::lua_isfunction(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isfunction(L,index);
  }
  else{
    return 0;
  }
}
int  Lua::lua_isuserdata(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isuserdata(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_islightuserdata(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_islightuserdata(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_isstring(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isstring(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_isboolean(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isboolean(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_istable(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_istable(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_isnil(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isnil(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_isnone(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isnone(L,index);

  }
  else{
    return 0;
  }
}
int  Lua::lua_isnoneornil(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_isnoneornil(L,index);
  }
  else{
    return 0;
  }
}
int  Lua::lua_type(void* L, int index){
  if(_initSuccess){
    return _arlua_lua_type(L,index);
  }
  else{
    return 0;
  }
}

  /**< stack manipulation */
int  Lua::lua_gettop(void* L){
  if(_initSuccess){
    return _arlua_lua_gettop(L);
  }
  else{
    return 0;
  }
}
void  Lua::lua_settop(void* L, int index){
  if(_initSuccess){
   _arlua_lua_settop(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_pop(void* L, int index){
  if(_initSuccess){
    _arlua_lua_pop(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_pushvalue(void* L, int index){
  if(_initSuccess){
    _arlua_lua_pushvalue(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_remove(void* L, int index){
  if(_initSuccess){
    _arlua_lua_remove(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_insert(void* L, int index){
  if(_initSuccess){
    _arlua_lua_insert(L,index);
  }
  else{
    return ;
  }
}
void  Lua::lua_replace(void* L, int index){
  if(_initSuccess){
    _arlua_lua_replace(L,index);
  }
  else{
    return ;
  }
}
int  Lua::lua_checkstack(void* L, int sz){
  if(_initSuccess){
    return _arlua_lua_checkstack(L,sz);
  }
  else{
    return 0 ;
  }
}


/**< garbage manipulation */
void Lua::luaC_collectgarbage(void* L){
  if(_initSuccess){
    _arlua_luaC_collectgarbage(L);
  }
  else{
    return ;
  }
}

int Lua::lua_gc(void* L, int what, int data){
  if(_initSuccess){
    return _arlua_lua_gc(L, what, data);
  }
  else{
    return -10000000;
  }
}

int Lua::lua_getgcthreshold(void* L){
  if(_initSuccess){
    return _arlua_lua_getgcthreshold(L);
  }
  return 0;
}

void Lua::lua_setgcthreshold(void* L,int threshold){
  if(_initSuccess){
    _arlua_lua_setgcthreshold(L,threshold);
  }
  return ;
}

//============================================================
//====LuaBind=================================================
//============================================================

bool LuaBind::_initSuccess=false;
map<StlString,const arluaL_reg*> LuaBind::_lookUp;

AR_CLASS_DEF(LuaBind,ArObject)

//----------------------------------------
LuaBind::LuaBind(ArCW& arCW):
ArObject(arCW){
}
//----------------------------------------
LuaBind::~LuaBind(){
}
//----------------------------------------
/**< helpfull functions */
ArRef<ArObject>
LuaBind::retrieveArRef(void* L,int index) {
  if(_initSuccess){
     if(L){
      LuaBind::lua_data_share* ds = (LuaBind::lua_data_share*)Lua::lua_touserdata(L,index);

      if(ds){
	cerr.flush();
	ArRef<ArObject> object = ((ds)->data)->thisRef();
	return object;
      }
      else{
	return ArObject::nullRef();
      }
    }
    else{
      return ArObject::nullRef();
    }
  }
  else{
    return ArObject::nullRef();
  }
}
//----------------------------------------
int
LuaBind::shareArRef (void* L, ArRef<ArObject> objShare/* , bool garbageCollected*/){

  if(!_initSuccess) return 0;

  if(!objShare || objShare==ArObject::nullRef() ){
    //cerr<<"pb while sharing ArRef: better abort simulation"<<endl;
    Lua::lua_pushnil(L);
    return 1;
  }

  if(!L){
    cerr<<"pb with L in shareArRef!"<<endl;
    return 0;
  }

  //retrieve the marshalling table in lua
  Lua::luaL_getmetatable(L,MARSHALLAREVILUA);

  //capture of current marshalling table index in stack
  int meta_index = Lua::lua_gettop(L);

  //the metatable doesn't exist->first time we share!
  if(!Lua::lua_istable(L,-1)){
    //the top is not the table remove it
    Lua::lua_pop(L,1);
    //create it
    LuaBind::createMarshallArea(L);
    //retrieve it
    Lua::luaL_getmetatable(L,MARSHALLAREVILUA);
    //update current marshalling table index in stack
    meta_index = Lua::lua_gettop(L);
  }

  //push the key on stack  : obj.c_ptr()
  Lua::lua_pushlightuserdata(L,(void*)objShare.c_ptr());
  //get value in marshalling table at this key : Metatable is leaved on stack!!!
  Lua::lua_gettable(L,meta_index);

  //the key is not an entry in table : object is not found
  if(!Lua::lua_isuserdata(L,-1)){

    //top value is not what we look for : remove it
    Lua::lua_pop(L,1);

    //create userdata pointer with lua allocation function
    LuaBind::lua_data_share* share =
      (LuaBind::lua_data_share*)Lua::lua_newuserdata(L,sizeof(LuaBind::lua_data_share)); //minimize allocation

    //now stack is |->  1: marshall 2:userdata

    //initialize field of shared data
    share->data = objShare.c_ptr();
    share->obj = new ArRef<ArObject>(objShare);

    //get index of userdata table
    int objShareTable = Lua::lua_gettop(L);

    //insert method in this table accordingly to its ancestors
    LuaBind::setLookUp(L,objShareTable);

    //push a key on stack
    Lua::lua_pushlightuserdata(L,(void*)objShare.c_ptr());
    //push a value on stack
    Lua::lua_pushvalue(L,objShareTable); //the metatable of object

    //now stack is |-> 1: marshall 2:userdata 3:lightuserdata 4:userdata

    //store the entry in the marshalling table
    // marshall[lightuserdata]=userdata (at index 4)
    Lua::lua_settable(L,meta_index);

    // now further sharing of this userdata can be retrieve with marshall[lightuserdata]
    //stack is |->  1: marshall 2:userdata
 }


  //remove metatable of marshalling & leave userdata on stack
  Lua::lua_remove(L,meta_index);

  //stack is |->  1:userdata

  //one element push on table the userdata
  return 1;

}

//--------------------------------------
// template<class T>
int
LuaBind::shareVectorArRef(void* L,StlVector<ArRef<ArObject> >& v){

  if(v.empty()) {
    Lua::lua_pushnil(L);
  }else{
    int narr = v.size();

    //Lua::lua_newtable(L);
    Lua::lua_createtable(L,narr,0);

    int table = Lua::lua_gettop(L); //table that will be return

    for(unsigned int i=0; i<v.size();i++){
      Lua::lua_pushnumber(L,i+1); /*value*/
      LuaBind::shareArRef(L,v[i]/*,false*/); /*key*/
      Lua::lua_settable(L,table);
    }
  }
  return 1;
}
//----------------------------------------
int
LuaBind::shareVectorDouble(void* L,StlVector<double>& v){
  if(v.empty()) return 0;
  int narr = v.size();

  //  Lua::lua_newtable(L);
  Lua::lua_createtable(L,narr,0);
  int table = Lua::lua_gettop(L); //table that will be return

  for(unsigned int i=0; i<v.size();i++){
    Lua::lua_pushnumber(L,i+1); /*value*/
    Lua::lua_pushnumber(L,v[i]); /*key*/
    Lua::lua_settable(L,table);
  }

  return 1;
}
//----------------------------------------
int
LuaBind::shareVectorInt(void* L,StlVector<int>& v){
  if(v.empty()) return 0;
  int narr = v.size();

  //Lua::lua_newtable(L);
   Lua::lua_createtable(L,narr,0);
   int table = Lua::lua_gettop(L); //table that will be return

  for(unsigned int i=0; i<v.size();i++){
    Lua::lua_pushnumber(L,i+1); /*value*/
    Lua::lua_pushnumber(L,v[i]); /*key*/
    Lua::lua_settable(L,table);
  }

  return 1;
}
//----------------------------------------
int
LuaBind::shareVectorStlString(void* L,StlVector<StlString>& v){
  if(v.empty()) return 0;
  int narr = v.size();

  //Lua::lua_newtable(L);
  Lua::lua_createtable(L,narr,0);
  int table = Lua::lua_gettop(L); //table that will be return

  for(unsigned int i=0; i<v.size();i++){
    Lua::lua_pushnumber(L,i+1); /*value*/
    Lua::lua_pushstring(L,v[i].c_str()); /*key*/
    Lua::lua_settable(L,table);
  }

  return 1;
}

//----------------------------------------
StlString //name of ancestor metatable
LuaBind::findMetaTable(void* L,int objIndex){

  if(!_initSuccess) return StlString("");

  CHECK_RETRIEVE_ARREF(L,obj,ArObject,objIndex)
//   ArRef<ArObject> obj = retrieveArRef(L,objIndex);

  if(!obj) return StlString("");

  StlString name  = obj->getClass()->getName();

  return findMetaTable(L,name);
}
//----------------------------------------
StlString //name of ancestor metatable
LuaBind::findMetaTable(void* L,StlString& clsName){

  if(!_initSuccess) return StlString("");

  ArConstRef<ArClass> superClass;

  superClass = ArClass::find(clsName);

  while(superClass){

    Lua::luaL_getmetatable(L,superClass->getName().c_str());
    if(Lua::lua_isnoneornil(L,-1)){
      Lua::lua_pop(L,1); //the top value
      superClass = superClass->getParent();
    }
    else{
      Lua::lua_pop(L,1); //the metatable
      return superClass->getName();
    }
  }

  return StlString(""); //hope to be never here
}
//----------------------------------------
void
LuaBind::setLookUp(void* L,int objIndex){
  if(!_initSuccess) return ;

  StlString metatable = LuaBind::findMetaTable(L,objIndex);

  if(metatable!=""){
    Lua::luaL_getmetatable(L,metatable.c_str());
    Lua::lua_setmetatable(L,objIndex);
  }
  else{
    ArRef<ArObject> obj = retrieveArRef(L,objIndex);
    cerr<<"Lua:: !!! Error while trying to find ";
    if(obj){
      cerr<<obj->getAlias()<<endl;
    }else{
      cerr<<endl;
      LuaInfo::checkLuaType(L,objIndex);
    }
    cerr<<" registered ancestor : none are available "<<endl;
    cerr<<"     create a metatable for this kind of objects "<<endl;
  }

}

//----------------------------------------
/**< class Export */
void
LuaBind::exportClass(void* L,
		       const char* clsName,
		       const arluaL_reg* methods ,
		       const arluaL_reg* constructor){
  map<StlString,const arluaL_reg*>::const_iterator it;

  Lua::luaL_newmetatable(L,clsName);
  int metatable = Lua::lua_gettop(L);
  Lua::lua_pushstring(L, "__index");
  Lua::lua_pushvalue(L,metatable);
  Lua::lua_settable(L,metatable);

  Lua::lua_pushstring(L,"__gc");
  Lua::lua_pushcfunction(L,LuaBind::destroy);
  Lua::lua_settable(L,metatable);


  Lua::luaL_openlib(L,
 		    NULL,
 		    methods,
 		    0); //fill metatable



  StlString ancestor;
  StlString name(clsName);
  ArConstRef<ArClass> classe = ArClass::find(name);
  ArConstRef<ArClass> super ;
  if(classe){
    super = classe->getParent();
    while(super){
      ancestor = super->getName();
      it = LuaBind::_lookUp.find(ancestor);
      if(it!=LuaBind::_lookUp.end()){
	Lua::luaL_openlib(L,NULL,(it->second),0);
      }
      else{
      }
      super=super->getParent();
    }
  }


  Lua::luaL_openlib(L,
 		    clsName,
 		    constructor,
 		    0);

  Lua::lua_pop(L,2);

  LuaBind::_lookUp[name]=methods;


}

//----------------------------------------
void
LuaBind::createMarshallArea(void *L){

  //Marshall area has name MarshallAReViLua
  int top = Lua::lua_gettop(L);

  StlString name = StlString(MARSHALLAREVILUA);

  Lua::luaL_newmetatable(L,name.c_str()); //table
  int metatable = Lua::lua_gettop(L);

  Lua::lua_newtable(L); //metatable
  int metametatable = Lua::lua_gettop(L);

  Lua::lua_pushstring(L,"__mode");
  Lua::lua_pushstring(L,"v");
  Lua::lua_settable(L,metametatable);

  Lua::lua_pushstring(L,"__metatable");
  Lua::lua_pushvalue(L,metametatable);
  Lua::lua_setmetatable(L,metatable);

  Lua::lua_settop(L,top);

}


//----------------------------------------
/**< needed to register destructor in lua bindings object*/
int
LuaBind::destroy(void* L){
  if(_initSuccess){

    //    CHECK_RETRIEVE_ARREF(L,obj,ArObject,1)

    LuaBind::lua_data_share* ds = (LuaBind::lua_data_share*)Lua::lua_touserdata(L,1);
    delete ds->obj;

    return 0;
  }
  else{
    return -1;
  }
}

//============================================================
//=====LuaInfo===============================================
//============================================================

bool LuaInfo::_initSuccess=false;

AR_CLASS_DEF(LuaInfo,ArObject)

//--------------------------------------
LuaInfo::LuaInfo(ArCW& arCW):
ArObject(arCW){
}

//--------------------------------------
LuaInfo::~LuaInfo(){
}
//--------------------------------------
void
LuaInfo::checkLuaType(void* L,int index){
  if(!_initSuccess) return;

  if(Lua::lua_istable(L,index)){
    cerr<<"  -->table "<<index<<endl;
  }
  if(Lua::lua_isnil(L,index)){
    cerr<<"  -->nil "<<index<<endl;
  }
  if(Lua::lua_islightuserdata(L,index)){
    cerr<<"  -->lightuserdata "<<index<<endl;
  }
  if(Lua::lua_isuserdata(L,index)){
    cerr<<"  -->userdata "<<index<<endl;
  }
  if(Lua::lua_isnone(L,index)){
    cerr<<"  -->none "<<index<<endl;
  }
  if(Lua::lua_isnumber(L,index)){
    cerr<<"  -->number "<<index<<endl;
  }
  if(Lua::lua_iscfunction(L,index)){
    cerr<<"  -->cfunction "<<index<<endl;
  }
  if(Lua::lua_isfunction(L,index)){
    cerr<<"  -->function "<<index<<endl;
  }
  if(Lua::lua_isstring(L,index)){
    cerr<<"  -->string "<<index<<endl;
  }
  if(Lua::lua_isboolean(L,index)){
    cerr<<"  -->boolean "<<index<<endl;
  }

}
//--------------------------------------
void
LuaInfo::dumpLuaStack(void* L){
  if(!_initSuccess) return;

  unsigned int top = Lua::lua_gettop(L);

  cerr<<"stack "<<L<<" size:"<<top<<endl;
  for(unsigned int i = 1; i<= top; i++){
    LuaInfo::checkLuaType(L,i);
  }


}
//--------------------------------------
void
LuaInfo::sizeofLuaStack(void* L){
  if(!_initSuccess) return;

  unsigned int top = Lua::lua_gettop(L);
  cerr<<"stack "<<L<<" size:"<<top<<endl;
}
//--------------------------------------

}//namespace

//----------------------------------------------------------------------------
