// LI2/ENIB - AReVi-Contrib - Cg context
//----------------------------------------------------------------------------
// file        : AReVi/Contrib/cgContext.cpp
// author(s)   : T. Jourdan
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/Contrib/cgContext.h"

#include "AReVi/Utils/urlStream.h"
#include "AReVi/arSystem.h"

namespace AReVi {

bool CgContext::_initSuccess = false;

CgContext::CgCTX (* CgContext::_createContext)(void) = (CgContext::CgCTX (*)(void))0;
void   (* CgContext::_destroyContext)(CgContext::CgCTX context) = (void (*)(CgContext::CgCTX))0;
CgContext::Program (* CgContext::_createProgram)(CgContext::CgCTX context, const StlString& code, CgContext::Profile profile, const StlString& entry, const StlVector<StlString> * args) = (CgContext::Program (*)(CgContext::CgCTX, const StlString&, CgContext::Profile, const StlString&, const StlVector<StlString>*))0;
CgContext::Program (* CgContext::_createProgramFromFile)(CgContext::CgCTX context, const StlString& filename, CgContext::Profile profile, const StlString& entry, const StlVector<StlString> * args) = (CgContext::Program (*)(CgContext::CgCTX, const StlString&, CgContext::Profile, const StlString&, const StlVector<StlString>*))0;
void   (* CgContext::_destroyProgram)(CgContext::Program program) = (void (*)(CgContext::Program))0;
void   (* CgContext::_enableProfile)(CgContext::Profile profile) = (void (*)(CgContext::Profile))0;
void   (* CgContext::_disableProfile)(CgContext::Profile profile) = (void (*)(CgContext::Profile))0;
bool   (* CgContext::_isProfileSupported)(CgContext::Profile profile) = (bool (*)(CgContext::Profile))0;
void   (* CgContext::_loadProgram)(CgContext::Program program) = (void (*)(CgContext::Program))0;
void   (* CgContext::_bindProgram)(CgContext::Program program) = (void (*)(CgContext::Program))0;
const char* (* CgContext::_getError)(void) = (const char* (*)(void))0;
void   (* CgContext::_setErrorCallback)(void (*callback)(void)) = (void (*)(void (*)(void)))0;
CgContext::Param (* CgContext::_getNamedParameter)(CgContext::Param program, const StlString& name) = (CgContext::Param (*)(CgContext::Param, const StlString&))0;
void   (* CgContext::_setParameter1f)(CgContext::Param parameter, float x) = (void (*)(CgContext::Param, float))0;
void   (* CgContext::_setParameter2f)(CgContext::Param parameter, float x, float y) = (void (*)(CgContext::Param, float, float))0;
void   (* CgContext::_setParameter3f)(CgContext::Param parameter, float x, float y, float z) = (void (*)(CgContext::Param, float, float, float))0;
void   (* CgContext::_setParameter4f)(CgContext::Param parameter, float x, float y, float z, float w) = (void (*)(CgContext::Param, float, float, float, float))0;
void   (* CgContext::_setParameter1fv)(CgContext::Param parameter, const float* array) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_setParameter2fv)(CgContext::Param parameter, const float* array) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_setParameter3fv)(CgContext::Param parameter, const float* array) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_setParameter4fv)(CgContext::Param parameter, const float* array) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_getParameter1f)(CgContext::Param parameter, float* array) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_getParameter2f)(CgContext::Param parameter, float* array) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_getParameter3f)(CgContext::Param parameter, float* array) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_getParameter4f)(CgContext::Param parameter, float* array) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_setParameter1d)(CgContext::Param parameter, double x) = (void (*)(CgContext::Param, double))0;
void   (* CgContext::_setParameter2d)(CgContext::Param parameter, double x, double y) = (void (*)(CgContext::Param, double, double))0;
void   (* CgContext::_setParameter3d)(CgContext::Param parameter, double x, double y, double z) = (void (*)(CgContext::Param, double, double, double))0;
void   (* CgContext::_setParameter4d)(CgContext::Param parameter, double x, double y, double z, double w) = (void (*)(CgContext::Param, double, double, double, double))0;
void   (* CgContext::_setParameter1dv)(CgContext::Param parameter, const double* array) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_setParameter2dv)(CgContext::Param parameter, const double* array) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_setParameter3dv)(CgContext::Param parameter, const double* array) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_setParameter4dv)(CgContext::Param parameter, const double* array) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_getParameter1d)(CgContext::Param parameter, double* array) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_getParameter2d)(CgContext::Param parameter, double* array) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_getParameter3d)(CgContext::Param parameter, double* array) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_getParameter4d)(CgContext::Param parameter, double* array) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_setMatrixParameterfr)(CgContext::Param parameter, const float* matrix) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_setMatrixParameterfc)(CgContext::Param parameter, const float* matrix) = (void (*)(CgContext::Param, const float*))0;
void   (* CgContext::_setMatrixParameterdr)(CgContext::Param parameter, const double* matrix) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_setMatrixParameterdc)(CgContext::Param parameter, const double* matrix) = (void (*)(CgContext::Param, const double*))0;
void   (* CgContext::_getMatrixParameterfr)(CgContext::Param parameter, float* matrix) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_getMatrixParameterfc)(CgContext::Param parameter, float* matrix) = (void (*)(CgContext::Param, float*))0;
void   (* CgContext::_getMatrixParameterdr)(CgContext::Param parameter, double* matrix) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_getMatrixParameterdc)(CgContext::Param parameter, double* matrix) = (void (*)(CgContext::Param, double*))0;
void   (* CgContext::_setStateMatrixParameter)(CgContext::Param parameter, CgContext::StateMatrixType state, CgContext::TransformMatrixType transform) = (void (*)(CgContext::Param, CgContext::StateMatrixType, CgContext::TransformMatrixType))0;
void   (* CgContext::_setParameterArray1f)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_setParameterArray2f)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_setParameterArray3f)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_setParameterArray4f)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_getParameterArray1f)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_getParameterArray2f)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_getParameterArray3f)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_getParameterArray4f)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_setParameterArray1d)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_setParameterArray2d)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_setParameterArray3d)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_setParameterArray4d)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_getParameterArray1d)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_getParameterArray2d)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_getParameterArray3d)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_getParameterArray4d)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_setMatrixParameterArrayfr)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_setMatrixParameterArrayfc)(CgContext::Param parameter, int startIndex, int numberOfElements, const float* array) = (void (*)(CgContext::Param, int, int, const float*))0;
void   (* CgContext::_getMatrixParameterArrayfr)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_getMatrixParameterArrayfc)(CgContext::Param parameter, int startIndex, int numberOfElements, float* array) = (void (*)(CgContext::Param, int, int, float*))0;
void   (* CgContext::_setMatrixParameterArraydr)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_setMatrixParameterArraydc)(CgContext::Param parameter, int startIndex, int numberOfElements, const double* array) = (void (*)(CgContext::Param, int, int, const double*))0;
void   (* CgContext::_getMatrixParameterArraydr)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_getMatrixParameterArraydc)(CgContext::Param parameter, int startIndex, int numberOfElements, double* array) = (void (*)(CgContext::Param, int, int, double*))0;
void   (* CgContext::_enableClientState)(CgContext::Param parameter) = (void (*)(CgContext::Param))0;
void   (* CgContext::_disableClientState)(CgContext::Param parameter) = (void (*)(CgContext::Param))0;
void   (* CgContext::_setParameterPointer)(CgContext::Param parameter, GLint size, GLenum type, GLsizei stride, GLvoid* array) = (void (*)(CgContext::Param, GLint, GLenum, GLsizei, GLvoid*))0;
void   (* CgContext::_enableTextureParameter)(CgContext::Param parameter) = (void (*)(CgContext::Param))0;
void   (* CgContext::_disableTextureParameter)(CgContext::Param parameter) = (void (*)(CgContext::Param))0;
GLuint (* CgContext::_getTextureParameter)(CgContext::Param parameter) = (GLuint (*)(CgContext::Param))0;
void   (* CgContext::_setTextureParameter)(CgContext::Param parameter, GLuint textureId) = (void (*)(CgContext::Param, GLuint))0;

AR_CLASS_DEF(CgContext, ArObject)

CgContext::CgContext(ArCW& arCW)
: ArObject(arCW) {
  if(CgContext::_initSuccess) {
    _context = _createContext();
  } else {
    _context = (CgContext::CgCTX)0;
  }
}

CgContext::~CgContext() {
  if(CgContext::_initSuccess) {
    _destroyContext(_context);
  }
}

CgContext::Program CgContext::createProgram(const StlString& code,
				   CgContext::Profile profile,
				   const StlString& entry,
				   const StlVector<StlString> * args) {
  if(CgContext::_initSuccess) {
    return CgContext::_createProgram(_context, code,
				     profile, entry, args);
  } else {
    return (CgContext::Program)0;
  }
}

CgContext::Program
CgContext::createProgramFromURL(const StlString & url,
                                CgContext::Profile profile,
                                const StlString & entry,
                                const StlVector<StlString> * args)
{
CgContext::Program program=(CgContext::Program)0;
if(!CgContext::_initSuccess)
  {
  return(program);
  }
ArRef<URLStream> input=URLStream::NEW(url);
if(input->fail())
  {
  return(program);
  }
if(input->getProtocol()=="file")
  {
  StlString fileName=input->getFileName();
  input.clear();
  program=CgContext::_createProgramFromFile(_context,fileName,
                                            profile,entry,args);
  }
else if(input->getProtocol()=="http")
  {
  StlString tmpName;
  int tmpFD=ArSystem::createTmpFile("./CG_",tmpName);
  if(tmpFD==-1)
    {
    return(program);
    }
  ArRef<FDOStream> output=FDOStream::NEW(tmpFD,true);
  if(!output->fail())
    {
    output->copyDataFromInput(input);
    input.clear();
    output.clear();
    program=CgContext::_createProgramFromFile(_context,tmpName,
                                              profile,entry,args);
    }
  ArSystem::removeFile(tmpName);
  }
return(program);
}

void CgContext::destroyProgram(CgContext::Program program) {
  if(CgContext::_initSuccess) {
    CgContext::_destroyProgram(program);
  }
}

void CgContext::enableProfile(CgContext::Profile profile) {
  if(CgContext::_initSuccess) {
    CgContext::_enableProfile(profile);
  }
}

void CgContext::disableProfile(CgContext::Profile profile) {
  if(CgContext::_initSuccess) {
    CgContext::_disableProfile(profile);
  }
}

bool CgContext::isProfileSupported(CgContext::Profile profile) {
  if(CgContext::_initSuccess) {
    return CgContext::_isProfileSupported(profile);
  } else {
    return false;
  }
}

void CgContext::loadProgram(CgContext::Program program) {
  if(CgContext::_initSuccess) {
    CgContext::_loadProgram(program);
  }
}

void CgContext::bindProgram(CgContext::Program program) {
  if(CgContext::_initSuccess) {
    CgContext::_bindProgram(program);
  }
}

const char* CgContext::getError(void) {
  if(CgContext::_initSuccess) {
    return CgContext::_getError();
  } else {
    return (const char*)0;
  }
}

void CgContext::setErrorCallback(void (*callback)(void)) {
  if(CgContext::_initSuccess) {
    CgContext::_setErrorCallback(callback);
  }
}

CgContext::Param CgContext::getNamedParameter(CgContext::Program program,
					 const StlString& name) {
  if(CgContext::_initSuccess) {
    return CgContext::_getNamedParameter(program, name);
  } else {
    return (CgContext::Param)0;
  }
}

void CgContext::setParameter1f(CgContext::Param parameter, float x) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter1f(parameter, x);
  }
}

void CgContext::setParameter2f(CgContext::Param parameter, float x, float y) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter2f(parameter, x, y);
  }
}

void CgContext::setParameter3f(CgContext::Param parameter, float x, float y, float z) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter3f(parameter, x, y, z);
  }
}

void CgContext::setParameter4f(CgContext::Param parameter, float x, float y, float z, float w) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter4f(parameter, x, y, z, w);
  }
}

void CgContext::setParameter1fv(CgContext::Param parameter, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter1fv(parameter, array);
  }
}

void CgContext::setParameter2fv(CgContext::Param parameter, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter2fv(parameter, array);
  }
}

void CgContext::setParameter3fv(CgContext::Param parameter, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter3fv(parameter, array);
  }
}

void CgContext::setParameter4fv(CgContext::Param parameter, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter4fv(parameter, array);
  }
}

void CgContext::getParameter1f(CgContext::Param parameter, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter1f(parameter, array);
  }
}

void CgContext::getParameter2f(CgContext::Param parameter, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter2f(parameter, array);
  }
}

void CgContext::getParameter3f(CgContext::Param parameter, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter3f(parameter, array);
  }
}

void CgContext::getParameter4f(CgContext::Param parameter, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter4f(parameter, array);
  }
}

void CgContext::setParameter1d(CgContext::Param parameter, double x) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter1d(parameter, x);
  }
}

void CgContext::setParameter2d(CgContext::Param parameter, double x, double y) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter2d(parameter, x, y);
  }
}

void CgContext::setParameter3d(CgContext::Param parameter, double x, double y, double z) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter3d(parameter, x, y, z);
  }
}

void CgContext::setParameter4d(CgContext::Param parameter, double x, double y, double z, double w) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter4d(parameter, x, y, z, w);
  }
}

void CgContext::setParameter1dv(CgContext::Param parameter, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter1dv(parameter, array);
  }
}

void CgContext::setParameter2dv(CgContext::Param parameter, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter2dv(parameter, array);
  }
}

void CgContext::setParameter3dv(CgContext::Param parameter, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter3dv(parameter, array);
  }
}

void CgContext::setParameter4dv(CgContext::Param parameter, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameter4dv(parameter, array);
  }
}

void CgContext::getParameter1d(CgContext::Param parameter, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter1d(parameter, array);
  }
}

void CgContext::getParameter2d(CgContext::Param parameter, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter2d(parameter, array);
  }
}

void CgContext::getParameter3d(CgContext::Param parameter, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter3d(parameter, array);
  }
}

void CgContext::getParameter4d(CgContext::Param parameter, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameter4d(parameter, array);
  }
}

void CgContext::setMatrixParameterfr(CgContext::Param parameter, const float* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterfr(parameter, matrix);
  }
}

void CgContext::setMatrixParameterfc(CgContext::Param parameter, const float* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterfc(parameter, matrix);
  }
}

void CgContext::setMatrixParameterdr(CgContext::Param parameter, const double* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterdr(parameter, matrix);
  }
}

void CgContext::setMatrixParameterdc(CgContext::Param parameter, const double* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterdr(parameter, matrix);
  }
}

void CgContext::getMatrixParameterfr(CgContext::Param parameter, float* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterfr(parameter, matrix);
  }
}

void CgContext::getMatrixParameterfc(CgContext::Param parameter, float* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterfc(parameter, matrix);
  }
}

void CgContext::getMatrixParameterdr(CgContext::Param parameter, double* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterdr(parameter, matrix);
  }
}

void CgContext::getMatrixParameterdc(CgContext::Param parameter, double* matrix) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterdc(parameter, matrix);
  }
}

void CgContext::setStateMatrixParameter(CgContext::Param parameter,
					CgContext::StateMatrixType state,
					CgContext::TransformMatrixType transform) {
  if(CgContext::_initSuccess) {
    CgContext::_setStateMatrixParameter(parameter, state, transform);
  }
}

void CgContext::setParameterArray1f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray1f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray2f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray2f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray3f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray3f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray4f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray4f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray1f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray1f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray2f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray2f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray3f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray3f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray4f(CgContext::Param parameter, int startIndex,
				    int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray4f(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray1d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray1d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray2d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray2d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray3d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray3d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setParameterArray4d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterArray4d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray1d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray1d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray2d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray2d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray3d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray3d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getParameterArray4d(CgContext::Param parameter, int startIndex,
				    int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getParameterArray4d(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setMatrixParameterArrayfr(CgContext::Param parameter, int startIndex,
					  int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterArrayfr(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setMatrixParameterArrayfc(CgContext::Param parameter, int startIndex,
					  int numberOfElements, const float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterArrayfc(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getMatrixParameterArrayfr(CgContext::Param parameter, int startIndex,
					  int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterArrayfr(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getMatrixParameterArrayfc(CgContext::Param parameter, int startIndex,
					  int numberOfElements, float* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterArrayfc(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setMatrixParameterArraydr(CgContext::Param parameter, int startIndex,
					  int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterArraydr(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::setMatrixParameterArraydc(CgContext::Param parameter, int startIndex,
					  int numberOfElements, const double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setMatrixParameterArraydc(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getMatrixParameterArraydr(CgContext::Param parameter, int startIndex,
					  int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterArraydr(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::getMatrixParameterArraydc(CgContext::Param parameter, int startIndex,
					  int numberOfElements, double* array) {
  if(CgContext::_initSuccess) {
    CgContext::_getMatrixParameterArraydc(parameter, startIndex, numberOfElements, array);
  }
}

void CgContext::enableClientState(CgContext::Param parameter) {
  if(CgContext::_initSuccess) {
    CgContext::_enableClientState(parameter);
  }
}

void CgContext::disableClientState(CgContext::Param parameter) {
  if(CgContext::_initSuccess) {
    CgContext::_disableClientState(parameter);
  }
}

void CgContext::setParameterPointer(CgContext::Param parameter, GLint size, GLenum type,
				    GLsizei stride, GLvoid* array) {
  if(CgContext::_initSuccess) {
    CgContext::_setParameterPointer(parameter, size, type, stride, array);
  }
}

void CgContext::enableTextureParameter(CgContext::Param parameter) {
  if(CgContext::_initSuccess) {
    CgContext::_enableTextureParameter(parameter);
  }
}

void CgContext::disableTextureParameter(CgContext::Param parameter) {
  if(CgContext::_initSuccess) {
    CgContext::_disableTextureParameter(parameter);
  }
}

GLuint CgContext::getTextureParameter(CgContext::Param parameter) {
  if(CgContext::_initSuccess) {
    return CgContext::_getTextureParameter(parameter);
  } else {
    return 0;
  }
}

void CgContext::setTextureParameter(CgContext::Param parameter, GLuint textureId) {
  if(CgContext::_initSuccess) {
    CgContext::_setTextureParameter(parameter, textureId);
  }
}

}// namespace AReVi

//----------------------------------------------------------------------------
