// LI2/ENIB - AReVi-Contrib - XML management
//----------------------------------------------------------------------------
// file        : AReVi/Contrib/xmlParser.cpp
// author(s)   : E. Cazeaux, E. Maffre
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/Contrib/xmlParser.h"
#include "AReVi/Utils/urlStream.h"
#include "AReVi/Utils/memoryStream.h"
#include "AReVi/Utils/memoryBlock.h"

#include "AReVi/arSystem.h"

namespace AReVi {

//-------- Initialization ----------------------------------------------------
//-------- XmlNode Static init
ArRef<XmlNode> (* XmlNode::_newRef)(ArRef<XmlNode> , void *)=(ArRef<XmlNode> (*)(ArRef<XmlNode> , void *))0;

void   (* XmlNode::_freeString)(void *)= (void (*)(void *))0;

char * (* XmlNode::_getName)(void *)   = (char * (*)(void *))0;

char * (* XmlNode::_getString)(void *) = (char * (*)(void *))0;

char * (* XmlNode::_getTextString)(void *)=  (char * (*)(void *))0;

char * (* XmlNode::_getProperty)(void *,  StlString)= (char * (*)(void *, StlString))0;

void * (* XmlNode::_getNext)(void *)= (void * (*)(void *))0;

void * (* XmlNode::_getPrevious)(void *)= (void * (*)(void *))0;

void * (* XmlNode::_getFirstChild)(void *)= (void * (*)(void *))0;

void * (* XmlNode::_getLastChild)(void *)= (void * (*)(void *))0;

void * (* XmlNode::_getParent)(void *) = (void * (*)(void *))0;

void * (* XmlNode::_getDoc)(void *) = (void * (*)(void *))0;


void (* XmlNode::_setName)(void *,const char *)=  (void (*)(void *, const char *))0;

void * (* XmlNode::_newNode)(void *, const char *)=  (void * (*)(void *, const char *))0;

void * (* XmlNode::_copyNode)(const void * , int )=(void * (* )(const void * , int ))0;

void   (* XmlNode::_freeNode)(void * , bool )=(void   (* )(void * , bool ))0;

void * (* XmlNode::_addChild)(void *, void *)=  (void * (*)(void *, void *))0;

void * (* XmlNode::_addText)(void *, const char *)=  (void * (*)(void *, const char *))0;

void * (* XmlNode::_addComment)(void *, const char *)=  (void * (*)(void *, const char *))0;

bool (* XmlNode::_isText)(void *)=  (bool (*)(void *))0;

bool (* XmlNode::_isComment)(void *)=  (bool (*)(void *))0;

void (* XmlNode::_setProperty)(void *,const StlString &,const StlString &)=  (void (*)(void *,const StlString &,const StlString &))0;
void (* XmlNode::_addProperty)(void *,const StlString &,const StlString &)=  (void (*)(void *,const StlString &,const StlString &))0;
bool (* XmlNode::_hasProperty)(void *,const StlString &)=  (bool (*)(void *,const StlString &))0;
bool (* XmlNode::_getPropertyList)(void *,StlVector<StlString> &)=  (bool (*)(void *,StlVector<StlString> &))0;
void (* XmlNode::_setString)(void *,const char *) =  (void (*)(void *,const char *))0;


//-------- TOOLS ----------------------------------------------
StlString (* XmlNode::_UTF8ToISO)(const StlString &utf8String)= (StlString (*)(const StlString &))0;
StlString (* XmlNode::_ISOToUTF8)(const StlString &ISOString)= (StlString (*)(const StlString &))0;

// --------- XmlParser Static init
bool XmlParser::_initSuccess=false;

bool   (* XmlParser::_newDocument)(void **)=   (bool (*)(void **))0;

bool   (* XmlParser::_parseFile)(StlString ,void **, bool , StlVector<XmlParser::XmlParseError> &)=
    (bool (*)(StlString, void **, bool , StlVector<XmlParser::XmlParseError> &))0;

bool   (* XmlParser::_parseDoc)(char *,void **, bool , StlVector<XmlParser::XmlParseError> &)=
    (bool (*)(char *, void **, bool , StlVector<XmlParser::XmlParseError> &))0;

bool   (* XmlParser::_saveFile)(StlString ,void *, const char *)=
    (bool (*)(StlString, void *, const char *))0;

bool   (* XmlParser::_saveDoc)(ArRef<AbstractOStream>,void *, const char *)=
    (bool (*)(ArRef<AbstractOStream>, void *, const char *))0;


void   (* XmlParser::_freeDoc)(void *)=
    (void (*)(void *))0;

void  * (* XmlParser::_getRoot)(void *)=
    (void * (*)(void *))0;

bool (* XmlParser::_setRoot)(void *, void  *)=
    (bool (*)(void *,void  *))0;

bool (* XmlParser::_matchPath)(void * doc, const StlString &, StlList<XmlParser::XmlContent> &)=
    (bool (*)(void * doc, const StlString &, StlList<XmlParser::XmlContent> &))0;

bool (* XmlParser::_applyXSLT)(ArRef<AbstractIStream> , ArRef<AbstractIStream>, ArRef<AbstractOStream>, bool,StlVector<XmlParser::XmlParseError> &)=
    (bool (*)(ArRef<AbstractIStream> , ArRef<AbstractIStream>, ArRef<AbstractOStream>, bool,StlVector<XmlParser::XmlParseError> &))0;


// --------- XmlFlowOut Static init
int    (* XmlFlowOut::_xmlNodeDump)(void * , void *,const int &, const char *)=
            (int (*)(void *,void *,const int &, const char *))0;
int    (* XmlFlowOut::_xmlSaveFileTo)(void * , void * , const char *)=(int (*)(void *, void *,const char *))0;
void * (* XmlFlowOut::_xmlOutputBufferCreateFile)(FILE *)= (void * (*)(FILE *))0;
int    (* XmlFlowOut::_xmlOutputBufferFlush)(void *)= (int (*)(void *))0;
int    (* XmlFlowOut::_xmlOutputBufferClose)(void *)= (int (*)(void *))0;

//----------------------------------------------------------------------------
// Class XmlParser
//----------------------------------------------------------------------------

AR_CLASS_DEF(XmlParser,ArObject)

//-------- Construction / Destruction ----------------------------------------
XmlParser::XmlParser(ArCW & arCW) // Protected
    : ArObject(arCW),
      _xmlDocPtr(NULL),
      _errors()
{
  if(XmlParser::_initSuccess)
  {
    if (!newDocument())
    {
      cerr << "[XmlParser] Failed no create new XmlParser" << endl;
      thisRef().destroy(); // FIXME: error msg instead of this UGLY destroy() ?
    }
  }
  else
  {
    setErrorMessage("XmlParser plugin not initialized");
  }
}

XmlParser::~XmlParser(void) // Protected
{
  if ( _xmlDocPtr )
  {
    if (_rootNode) _rootNode.destroy(); // UGLY !

  // Destruction du document (=>et de tous les noeuds meme si y en a plus!)
    XmlParser::_freeDoc(_xmlDocPtr);
  }
}

bool
XmlParser::newDocument(void)
{
  if ( XmlParser::_initSuccess)
  {
    if (_rootNode) _rootNode.destroy(); // UGLY !

  // Destruction du document=>et de tous les noeuds!
    if(_xmlDocPtr) XmlParser::_freeDoc(_xmlDocPtr);
    _xmlDocPtr=NULL;

    bool ret=XmlParser::_newDocument(&_xmlDocPtr);
    if (ret)
      if (XmlParser::_setRoot(_xmlDocPtr, XmlNode::_newNode(NULL,"Root")))
        return _buildTreeNodes();
  }
  return false;
}

bool
XmlParser::parseFile(StlString fileName, bool processInclude, bool verbose)
{
  if ( XmlParser::_initSuccess)
  {
    if (_rootNode) _rootNode.destroy(); // UGLY !

    if(_xmlDocPtr) XmlParser::_freeDoc(_xmlDocPtr);
    _xmlDocPtr=NULL;

    _errors.clear();
    if (XmlParser::_parseFile(fileName,&_xmlDocPtr,processInclude,_errors))
      {
      if (verbose) XmlParser::displayErrors(_errors);
      return _buildTreeNodes();
      }
    else if (verbose) XmlParser::displayErrors(_errors);
  }
  return false;
}

bool
XmlParser::parseStream(ArRef<AbstractIStream> stream, bool processInclude, bool verbose)
{
  if (!XmlParser::_initSuccess) return false;
  if(stream->fail()) return false;

  if (_rootNode) _rootNode.destroy(); // UGLY !


  if(_xmlDocPtr) XmlParser::_freeDoc(_xmlDocPtr);
    _xmlDocPtr=NULL;

  ArRef<MemoryBlock> block=MemoryBlock::NEW();
  ArRef<MemoryOStream> memStream=MemoryOStream::NEW(block,0);
  memStream->copyDataFromInput(stream);
  memStream->stream() << '\0';
  _errors.clear();
  if (_parseDoc((char *)block->getMemory(),&_xmlDocPtr,processInclude,_errors))
    {
    if (verbose) XmlParser::displayErrors(_errors);
    return _buildTreeNodes();
    }
  else
    {
    if (verbose) XmlParser::displayErrors(_errors);
    return false;
    }
}

bool
XmlParser::parseFlow(StlString fileName, bool processInclude, bool verbose)
{
  if (!XmlParser::_initSuccess) return false;
  if (_rootNode) _rootNode.destroy(); // UGLY !

  if(_xmlDocPtr) XmlParser::_freeDoc(_xmlDocPtr);
  _xmlDocPtr=NULL;

  const char *header="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n<FLOWROOT>\n";
  const char *footer="</FLOWROOT>";

  ArRef<URLStream> stream=URLStream::NEW(fileName);
  if(stream->fail()) return false;

  ArRef<MemoryBlock> block=MemoryBlock::NEW();
  ArRef<MemoryOStream> memStream=MemoryOStream::NEW(block,0);
  memStream->stream()<<header;
  memStream->copyDataFromInput(stream);
  memStream->stream() << footer << '\0';

  _errors.clear();
  if (_parseDoc((char *)block->getMemory(),&_xmlDocPtr,processInclude,_errors))
    {
    if (verbose) XmlParser::displayErrors(_errors);
    return _buildTreeNodes();
    }
  else
    {
    if (verbose) XmlParser::displayErrors(_errors);
    return false;
    }
}

const
StlVector<XmlParser::XmlParseError> &
XmlParser::getParseErrors(void) const
{
return(_errors);
}

void // staic
XmlParser::displayErrors(const StlVector<XmlParseError> &errors)
{
for (unsigned i=0;i<errors.size();i++)
  {
  StlString level;
  if (errors[i].level==1)
    level="Warning";
  else if (errors[i].level==2)
    level="Error";
  else  if (errors[i].level==3)
    level="Error";
  else
    level="?";

  cerr << "XmlParser" << level  << "[" << errors[i].file << ":" << errors[i].line << "]=>" << errors[i].message;
  }
}

bool
XmlParser::saveFile(StlString fileName,const StlString  &encoding)
{
  if ( XmlParser::_initSuccess)
  {
    if (encoding!="")
      return XmlParser::_saveFile(fileName,_xmlDocPtr,encoding.c_str());
    else
      return XmlParser::_saveFile(fileName,_xmlDocPtr,NULL);
  }
  return false;
}

// Save xml top stream
bool
XmlParser::saveStream(ArRef<AbstractOStream> stream, const StlString  &encoding)
{
  if ( XmlParser::_initSuccess)
  {
    if (encoding!="")
      return XmlParser::_saveDoc(stream,_xmlDocPtr,encoding.c_str());
    else
      return XmlParser::_saveDoc(stream,_xmlDocPtr,NULL);
  }
  return false;
}

ArRef<XmlNode>
XmlParser::getRoot(void)
{
  if ( XmlParser::_initSuccess)
    return _rootNode;
  return XmlNode::nullRef();
}

bool
XmlParser::setRoot(const StlString &rootName)
{
  if ( XmlParser::_initSuccess)
  {
    if (_rootNode)
    {
      _rootNode->setName(rootName);
      return true;
    }
  }
  return false;
}

//-------- XPath -------------------------------------------------------------
bool // success
XmlParser::matchPath(const StlString &pathExpr, StlList<XmlContent> &contentsOut) const
{
if ( XmlParser::_initSuccess)
  {
  if (_rootNode)
    {
    return(XmlParser::_matchPath(_xmlDocPtr,pathExpr, contentsOut));
    }
  }
  return(false);
}

//-------- XSLT -------------------------------------------------------------

bool // success
XmlParser::applyXSLT(ArRef<AbstractIStream> xmlInput, //static
          ArRef<AbstractIStream> styleSheet,
          ArRef<AbstractOStream> output,
          bool processInclude,
          StlVector<XmlParser::XmlParseError> *errorsOut)
{
if ( XmlParser::_initSuccess)
  {
  bool result;
  if (errorsOut)
    {
    result=(XmlParser::_applyXSLT(xmlInput,styleSheet, output, processInclude,*errorsOut));
    XmlParser::displayErrors(*errorsOut);
    }
  else
    {
    StlVector<XmlParser::XmlParseError> errors;
    result=(XmlParser::_applyXSLT(xmlInput,styleSheet, output, processInclude,errors));
    XmlParser::displayErrors(errors);
    }
  return(result);
  }
return(false);
}


//------- protected ---------------------------------------------------
// Construit l'arbre de noeud XML
bool XmlParser::_buildTreeNodes(void) //virtual
{
  void * root=XmlParser::_getRoot(_xmlDocPtr);

  if (root)
    _rootNode=XmlNode::_newXmlNode(XmlNode::nullRef(), root);
  else
  {
    _rootNode=XmlNode::nullRef();
    return false;
  }
  return _rootNode->_buildXmlNodeChilds();
}


//----------------------------------------------------------------------------
// Class XmlNode
//----------------------------------------------------------------------------
AR_CLASS_NOVOID_DEF(XmlNode,ArObject)

//-------- Construction / Destruction ----------------------------------------
XmlNode::XmlNode(ArCW & arCW,ArRef<XmlNode> parent, void * xmlNode) // Protected
    : ArObject(arCW), _xmlNode(xmlNode), _parent(parent), _childs()
{
// Nothing to be done!
}


XmlNode::~XmlNode(void) // Protected
{
  if(XmlParser::_initSuccess && _xmlNode)
  {
    if (_parent) _parent->_removeChild(_xmlNode);
    StlMap<void *, ArRef<XmlNode> >::iterator it=_childs.begin();
    StlMap<void *, ArRef<XmlNode> >::iterator it_end=_childs.end();

    while(it!=it_end)
    {
      if (!removeChild(it->second))
      {
        cerr << "[XmlParser] ERROR removing child in destruction of XmlNode " << getAlias() << "=" << getName() << endl;
        break;
      }
      it=_childs.begin();
    }
    //cerr << "Free node alias=" << getAlias() << "  named=" << getName() << endl;
    XmlNode::_freeNode(_xmlNode,true);
    _xmlNode=NULL;
  }
}

StlString
XmlNode::getName(void)
{
  StlString name;
  if(XmlParser::_initSuccess)
  {
    char *field=XmlNode::_getName(_xmlNode);
    if (field)
    {
      name = StlString((char *)field);
      // No free here!
    }
    else name="";
  }
  return name;
}

void
XmlNode::setName(const StlString &name)
{
  if(XmlParser::_initSuccess)
    XmlNode::_setName(_xmlNode,name.c_str());
}

StlString
XmlNode::getString(void)
{
  StlString name;
  if(XmlParser::_initSuccess)
  {
    char *field=XmlNode::_getString(_xmlNode);
    if (field)
    {
      name = StlString((char *)field);
      XmlNode::_freeString(field);
    }
    else name="";
  }
  return name;
}

// Renvoi le texte dans une balise.
// <A>Mon texte</A> => il faut faire nodeA->getTextString();
// Retourne false si la balise est vide eg: <A/> ou <A></A>
bool XmlNode::getTextString(StlString &textOut, const bool &useISOencoding/*=false*/) //virtual
{
  if(XmlParser::_initSuccess)
  {
    ArRef<XmlNode> child=getChild("text");
    if (child)
    {
      textOut=child->getString();
      if (useISOencoding && textOut.length()) textOut=UTF8ToISO(textOut);
      return true;
    }
  }
  return false;
}

StlString // concatenation of text nodes under this one
XmlNode::flattenText(void)
{
StlVector<StlString> txt;
int last=-1;
ArRef<XmlNode> child=getFirstChild();
while(child)
  {
  if(child->getName()=="text")
    {
    txt.push_back(child->getString());
    if(last>=0)
      {
      int offset=txt[last].size()-txt.back().size();
      if(offset>=0)
        {
        int index=txt[last].find(txt.back(),offset);
        if(index>=0)
          {
          txt[last]=txt[last].substr(0,index);
          }
        }
      }
    last=txt.size()-1;
    }
  else
    {
    txt.push_back(child->flattenText());
    }
  child=child->getNext();
  }
StlString result;
for(unsigned int i=0;i<txt.size();i++)
  {
  result+=txt[i];
  }
return(result);
}

void
XmlNode::setString(const StlString &text)
{
  if(XmlParser::_initSuccess)
    {
    while(_childs.size())
      {
      if (_childs.begin()->second.valid())
        _childs.begin()->second.destroy(); // force destruction  of child
      else
        {
        cerr << "[XmlParser] WARNING : Internal reference node is null !!!" << endl;
        break;
        }
      }

    XmlNode::_setString(_xmlNode,text.c_str());
    _buildXmlNodeChilds();
    }
}



StlString
XmlNode::getProperty(const StlString &name)
{
  StlString prop;
  if(XmlParser::_initSuccess)
  {
    char *field=XmlNode::_getProperty(_xmlNode,name);
	  if (field)
    {
      prop = StlString((char *)field);
      XmlNode::_freeString(field);
    }
    else prop="";
  }
  return prop;
}

bool
XmlNode::getPropertyString(const StlString &name, StlString &value)
{
  if(XmlParser::_initSuccess)
  {
    if (hasProperty(name))
    {
      value=getProperty(name);
      return true;
    }
  }
  return false;
}

bool
XmlNode::getPropertyInteger(const StlString &name, int &value)
{
  if(XmlParser::_initSuccess)
  {
    if (hasProperty(name))
      return strToInt(value,getProperty(name));
  }
  return false;
}

bool
XmlNode::getPropertyReal(const StlString &name, double &value)
{
  if(XmlParser::_initSuccess)
  {
    if (hasProperty(name))
      return strToDouble(value,getProperty(name));
  }
  return false;
}

bool
XmlNode::getPropertyBoolean(const StlString &name, bool &value)
{
  if(XmlParser::_initSuccess)
  {
    if (hasProperty(name))
    {
      StlString prop=getProperty(name);
      value=(prop=="TRUE" || prop=="true");
      return (value || prop=="FALSE" || prop=="false");
    }
  }
  return false;
}

ArRef<XmlNode>
XmlNode::getNext(void)
{
  ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;
  if ( XmlParser::_initSuccess)
  {
    void * t = XmlNode::_getNext(_xmlNode);
    if ( t && _parent) return _parent->_getChild(t);
  }
  return n;
}


ArRef<XmlNode>
XmlNode::getPrevious(void)
{
  ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;

  if ( XmlParser::_initSuccess)
  {
    void * t = XmlNode::_getPrevious(_xmlNode);
    if ( t && _parent) return _parent->_getChild(t);
  }
  return n;
}


ArRef<XmlNode>
XmlNode::getFirstChild(void){
    ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;
    if ( XmlParser::_initSuccess) {
	void * t = XmlNode::_getFirstChild(_xmlNode);
	if ( t ) return _getChild(t);
    }
    return n;
}

ArRef<XmlNode>
XmlNode::getLastChild(void){
    ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;
    if ( XmlParser::_initSuccess) {
	void * t = XmlNode::_getLastChild(_xmlNode);
	if ( t ) return _getChild(t);
    }
    return n;
}


ArRef<XmlNode>
XmlNode::getParent(void){
    if ( XmlParser::_initSuccess)
    {
      return _parent;
    }
    return XmlNode::nullRef();
}

// Find the occurence ieme of the child with name "childName"
ArRef<XmlNode> XmlNode::getChild(const StlString &childName, unsigned int occurence/*=1*/)
{
  if (!XmlParser::_initSuccess) return XmlNode::nullRef();
  unsigned currentOccurence=0;

  //cerr << "look for childName=" << childName << "   occurence=" << occurence << endl;

  ArRef<XmlNode> child=getFirstChild();
  while(child)
  {
    //cerr << "compare with " << child->getName() << endl;

    if (child->getName()==childName)
    {
      currentOccurence++;
      if (currentOccurence==occurence) return child;
    }
    child=child->getNext();
  }
  return XmlNode::nullRef();
}

// Test nodes types
bool
XmlNode::isText(void) const
{
if (XmlParser::_initSuccess && _xmlNode)
  return(XmlNode::_isText(_xmlNode));
else
  return(false);
}

bool
XmlNode::isComment(void) const
{
if (XmlParser::_initSuccess && _xmlNode)
  return(XmlNode::_isComment(_xmlNode));
else
  return(false);
}


ArRef<XmlNode>
XmlNode::addChild(const StlString &nodeName)
{
  ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;

  if ( XmlParser::_initSuccess)
  {
    void * t = XmlNode::_addChild(_xmlNode,XmlNode::_newNode(NULL,nodeName.c_str()));
    if ( t )
    {
      _childs[t]=_newXmlNode(thisRef(),t);
      n=_childs[t];
    }
  }
  return n;
}

ArRef<XmlNode>
XmlNode::addText(const StlString &text) // Add a text node (name is "text")
{
  ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;

  if ( XmlParser::_initSuccess)
  {
    void * t = XmlNode::_addText(_xmlNode,text.c_str());
    if ( t )
    {
      _childs[t]=_newXmlNode(thisRef(),t);
      n=_childs[t];
    }
  }
  return n;
}

ArRef<XmlNode>
XmlNode::addComment(const StlString &comment) // Add a comment node (name is "comment")
{
  ArRef<XmlNode> n = (ArRef<XmlNode>)NULL ;

  if ( XmlParser::_initSuccess)
  {
    void * t = XmlNode::_addComment(_xmlNode,comment.c_str());
    if ( t )
    {
      _childs[t]=_newXmlNode(thisRef(),t);
      n=_childs[t];
    }
  }
  return n;
}


bool XmlNode::removeChild(ArRef<XmlNode> node)
{
  if (!node) return false;

  if ( XmlParser::_initSuccess)
  {
    if (!node->_xmlNode) return false;

    StlMap<void *, ArRef<XmlNode> >::iterator it=_childs.find(node->_xmlNode);
    if (it!=_childs.end())
    {
      if (node==it->second)
      {
        it->second.destroy(); // UGLY !
        return true;
      }
      else
      {
        cerr << "[XmlParser] ERROR : 2 references node pointing the same data!!!" << endl;
      }
    }
  }
  return false;
}

void
XmlNode::setProperty(const StlString &name, const StlString &value)
{
  if ( XmlParser::_initSuccess)
  {
    if (!hasProperty(name))
      XmlNode::_addProperty(_xmlNode,name,value);
    else
      XmlNode::_setProperty(_xmlNode,name,value);
  }
}

bool
XmlNode::hasProperty(const StlString &name)
{
  if (XmlParser::_initSuccess && _xmlNode)
    return XmlNode::_hasProperty(_xmlNode,name);
  return false;
}

bool XmlNode::getPropertyList(StlVector<StlString> &namesOut)
{
  if (XmlParser::_initSuccess && _xmlNode)
    return XmlNode::_getPropertyList(_xmlNode,namesOut);
  return false;
}

void
XmlNode::setPropertyString(const StlString &name, const StlString &value)
{
  if(XmlParser::_initSuccess)
    setProperty(name,value);
}

void
XmlNode::setPropertyInteger(const StlString &name, const int &value)
{
  if(XmlParser::_initSuccess)
    setProperty(name,intToStr(value));
}

void
XmlNode::setPropertyReal(const StlString &name,const double &value)
{
  if(XmlParser::_initSuccess)
    setProperty(name,doubleToStr(value));
}

void
XmlNode::setPropertyBoolean(const StlString &name, const bool &value)
{
  if(XmlParser::_initSuccess)
  {
    if (value)
      setProperty(name,"TRUE");
    else
      setProperty(name,"FALSE");
  }
}

StlString
XmlNode::UTF8ToISO(const StlString &utf8String) // static
{
  if(XmlParser::_initSuccess)
    return _UTF8ToISO(utf8String);
  else return "";
}

StlString
XmlNode::ISOToUTF8(const StlString &ISOString) // static
{
  if(XmlParser::_initSuccess)
    return _ISOToUTF8(ISOString);
  else return "";
}

//-------- forbiden operations ----------------------------------------
ArRef<XmlNode>
XmlNode::_newXmlNode(ArRef<XmlNode> parent, void *node)
{
ArRef<XmlNode> ref(new XmlNode(XmlNode::_CLS,parent,node));
ref->setTransient(true);
XmlNode::_newRef(ref,node);
return(ref);
}

// Ajoute les enfants a un noeud XML
bool XmlNode::_buildXmlNodeChilds(void) //virtual
{
  void * pNode = XmlNode::_getFirstChild(_xmlNode);
  while ( pNode )
  {
    _childs[pNode]=_newXmlNode(thisRef(),pNode);
    _childs[pNode]->_buildXmlNodeChilds();
    pNode=XmlNode::_getNext(pNode);
  }
  return true;
}



// Enleve un enfant de la liste
bool XmlNode::_removeChild(void *xmlNode) //virtual
{
  StlMap<void *, ArRef<XmlNode> >::iterator it=_childs.find(xmlNode);
  if (it!=_childs.end())
  {
    _childs.erase(_childs.find(xmlNode));
    return true;
  }
  return false;
}


//----------------------------------------------------------------------------
// Class XmlFlowOut
//----------------------------------------------------------------------------
AR_CLASS_NOVOID_DEF(XmlFlowOut,XmlParser)

    //-------- Construction / Destruction ----------------------------------------

XmlFlowOut::XmlFlowOut(ArCW & arCW, const StlString &fileName) // Protected
    : XmlParser(arCW) , _xmlBufferPtr(NULL),_file(NULL)
{
    if(XmlParser::_initSuccess)
    {
      _file=fopen(fileName.c_str(),"w+t");
      if (!_file)
      {
        cerr << "XMLParser :: can't create file '" << fileName << "'" << endl;
        return;
      }
      _xmlBufferPtr=(void *)XmlFlowOut::_xmlOutputBufferCreateFile(_file);
      if (!_xmlBufferPtr)
      {
        cerr << "XMLParser :: can't create buffer for file '" << fileName << "'" << endl;
        fclose(_file);
        return;
      }
    }
}

XmlFlowOut::~XmlFlowOut(void) // Protected
{
  if ( _xmlBufferPtr )
    XmlFlowOut::_xmlOutputBufferClose(_xmlBufferPtr);

  if (_file)
    fclose(_file);
}

// Add XmlNode (and subnodes...)
// Default : level=0, encode="ISO-8859-1"
bool XmlFlowOut::addXmlNode(ArRef<XmlNode> node, const int &level, const StlString &encode) //virtual
{
  if(!XmlParser::_initSuccess || !node) return false;

  if (encode!="") XmlFlowOut::_xmlNodeDump(_xmlBufferPtr, node->_xmlNode,level,encode.c_str());
  else XmlFlowOut::_xmlNodeDump(_xmlBufferPtr, node->_xmlNode,level,NULL);

  XmlFlowOut::_xmlOutputBufferFlush(_xmlBufferPtr);
  fputc('\n',_file);
  fflush(_file);

  return true;
}

} // namespace AReVi
//----------------------------------------------------------------------------
