// LI2/ENIB - AReVi - 3D services
//----------------------------------------------------------------------------
// file        : AReVi/Lib3D/embeddedWindow3D.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/Lib3D/embeddedWindow3D.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class EmbeddedWindow3D
//----------------------------------------------------------------------------

AR_CLASS_NOVOID_DEF(EmbeddedWindow3D,Window3D)

//-------- Construction / Destruction ----------------------------------------

EmbeddedWindow3D::EmbeddedWindow3D(ArCW & arCW,
                                   int externalWindowID) // Protected
: Window3D(arCW),
  _externalWindowID(externalWindowID)
{
unsigned int minWidth=8;
unsigned int minHeight=8;
_renderArea=LLW::createEmbeddedWindow(_externalWindowID,
                                      0,0,minWidth,minHeight);
LLW::setWindowMinSize(_renderArea,minWidth,minHeight);
_afterRenderAreaSetup();
}

EmbeddedWindow3D::~EmbeddedWindow3D(void) // Protected
{
LLW::destroyWindow(_renderArea,false);
}

//-------- Window ID ---------------------------------------------------------

int // platform-specific external window ID
EmbeddedWindow3D::getExternalWindowID(void) const
{
return(_externalWindowID);
}

} // namespace AReVi

//----------------------------------------------------------------------------
