// LI2/ENIB - AReVi - Utility services
//----------------------------------------------------------------------------
// file        : AReVi/Utils/inputDevice.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/Utils/inputDevice.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class InputDevice (abstract)
//----------------------------------------------------------------------------

AR_CLASS_NOVOID_DEF(InputDevice,ArObject)

//-------- Construction / Destruction ----------------------------------------

InputDevice::InputDevice(ArCW & arCW,
                         const StlString & device) // Protected
: ArObject(arCW),
  _device(device),
  _buttons(),
  _axes()
{
  // Nothing to be done
}

InputDevice::~InputDevice(void) // Protected
{
  // Nothing to be done
}

//-------- Device management -------------------------------------------------

const StlString & // device
InputDevice::getDevice(void) const
{
return(_device);
}

// bool // success
// InputDevice::reset(const StlString & device)=0

// void
// InputDevice::update(void)=0

//-------- Buttons -----------------------------------------------------------

unsigned int // number of buttons
InputDevice::getNbButtons(void) const
{
return(_buttons.size());
}

bool // button is pressed
InputDevice::getButtonState(unsigned int buttonIndex) const
{
return(_buttons[buttonIndex]);
}

//-------- Axes --------------------------------------------------------------

unsigned int // number of axes
InputDevice::getNbAxes(void) const
{
return(_axes.size());
}

double // axis position [-1.0;1.0]
InputDevice::getAxis(unsigned int axisIndex) const
{
return(_axes[axisIndex]);
}

} // namespace AReVi

//----------------------------------------------------------------------------
