// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/geometryNode_priv.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/VRML/geometryNode_priv.h"

#include "AReVi/VRML/shapeNode_priv.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class GeometryNode
//----------------------------------------------------------------------------

//-------- Construction / Destruction ----------------------------------------

GeometryNode::~GeometryNode(void)
{
  // Nothing to be done
}

//-------- Inspection --------------------------------------------------------

bool // is a geometry
GeometryNode::isGeometry(void) const
{
return(true);
}

bool // made of triangles
GeometryNode::isSurface(void) const
{
return(true);
}

//-------- Rendering ---------------------------------------------------------

void
GeometryNode::postRebuild(void)
{
if(!_needsRebuild)
  {
  for(unsigned int i=_parents.size();i--;)
    {
    static_cast<ShapeNode *>(_parents[i])->postGeometryRebuild();
    }
  _needsRebuild=true;
  }
}

// void
// GeometryNode::updatePart(ArRef<ShapePart3D> part,
//                          const MaterialNode * material) const=0

//-------- Forbidden operations ----------------------------------------------

GeometryNode::GeometryNode(const StlString & nodeType,
                           VrmlShape3D * shape) // Protected
: VrmlNode(nodeType,shape)
{
  // Nothing to be done
}

} // namespace AReVi

//----------------------------------------------------------------------------
