// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/vrmlInlineInteractor.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/VRML/vrmlInlineInteractor.h"

#include "AReVi/VRML/inlineNode_priv.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class VrmlInlineInteractor
//----------------------------------------------------------------------------

AR_CLASS_DEF(VrmlInlineInteractor,VrmlInteractor)

//-------- Forbidden operations ----------------------------------------------

VrmlInlineInteractor::VrmlInlineInteractor(ArCW & arCW) // Protected
: VrmlInteractor(arCW)
{
  // Nothing to be done
}

VrmlInlineInteractor::~VrmlInlineInteractor(void) // Protected
{
  // Nothing to be done
}

//-------- Connection --------------------------------------------------------

bool // success
VrmlInlineInteractor::connectToNode(ArRef<VrmlShape3D> shape,
                                    const StlString & nodeName,
                                    int occurence)
{
if(VrmlInteractor::connectToNode(shape,nodeName,occurence)&&
   (_node->getType()=="Inline"))
  {
  return(true);
  }
else
  {
  disconnect();
  return(false);
  }
}

bool // success
VrmlInlineInteractor::connectTo(ArConstRef<VrmlInteractor> interactor)
{
if(VrmlInteractor::connectTo(interactor)&&
   (_node->getType()=="Inline"))
  {
  return(true);
  }
else
  {
  disconnect();
  return(false);
  }
}

//-------- Parameters --------------------------------------------------------

bool // success
VrmlInlineInteractor::readUrlField(StlVector<StlString> & urlOut) const
{
const InlineNode * node=static_cast<const InlineNode *>(_node);
if(node)
  {
  urlOut=node->_urlField;
  return(true);
  }
else
  {
  return(false);
  }
}

bool // success
VrmlInlineInteractor::writeUrlField(const StlVector<StlString> & url)
{
InlineNode * node=static_cast<InlineNode *>(_node);
if(node)
  {
  node->_urlField=url;
  // node->postRebuild(); // does not need to rebuild the shape
  return(true);
  }
else
  {
  return(false);
  }
}

} // namespace AReVi

//----------------------------------------------------------------------------
