// LI2/ENIB - AReVi - VRML services
//----------------------------------------------------------------------------
// file        : AReVi/VRML/vrmlShapeInteractor.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/VRML/vrmlShapeInteractor.h"

#include "AReVi/VRML/shapeNode_priv.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class VrmlShapeInteractor
//----------------------------------------------------------------------------

AR_CLASS_DEF(VrmlShapeInteractor,VrmlInteractor)

//-------- Construction / Destruction ----------------------------------------

VrmlShapeInteractor::VrmlShapeInteractor(ArCW & arCW) // Protected
: VrmlInteractor(arCW)
{
  // Nothing to be done
}

VrmlShapeInteractor::~VrmlShapeInteractor(void) // Protected
{
  // Nothing to be done
}

//-------- Connection --------------------------------------------------------

bool // success
VrmlShapeInteractor::connectToNode(ArRef<VrmlShape3D> shape,
                                   const StlString & nodeName,
                                   int occurence)
{
if(VrmlInteractor::connectToNode(shape,nodeName,occurence)&&
   (_node->getType()=="Shape"))
  {
  return(true);
  }
else
  {
  disconnect();
  return(false);
  }
}

bool // success
VrmlShapeInteractor::connectTo(ArConstRef<VrmlInteractor> interactor)
{
if(VrmlInteractor::connectTo(interactor)&&
   (_node->getType()=="Shape"))
  {
  return(true);
  }
else
  {
  disconnect();
  return(false);
  }
}

//-------- Shape parts -------------------------------------------------------

bool // success
VrmlShapeInteractor::getParts(StlVector<ArConstRef<ShapePart3D> > & partsOut)
                                                                         const
{
const ShapeNode * node=static_cast<const ShapeNode *>(_node);
if(node)
  {
  node->getParts(partsOut);
  return(true);
  }
else
  {
  return(false);
  }
}

bool // success
VrmlShapeInteractor::accessParts(StlVector<ArRef<ShapePart3D> > & partsOut)
{
ShapeNode * node=static_cast<ShapeNode *>(_node);
if(node)
  {
  node->accessParts(partsOut);
  return(true);
  }
else
  {
  return(false);
  }
}

} // namespace AReVi

//----------------------------------------------------------------------------
