// LI2/ENIB - AReVi - Core services
//----------------------------------------------------------------------------
// file        : AReVi/arConstant.cpp
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReVi/arConstant.h"

#include "AReVi/arValue.h"

namespace AReVi {

//----------------------------------------------------------------------------
// Class ArConstant
//----------------------------------------------------------------------------

AR_CLASS_NOVOID_DEF(ArConstant,ArObject)

//-------- Construction / Destruction ----------------------------------------

ArConstant::ArConstant(ArCW & arCW,
                       ArConstRef<ArClass> declCls,
                       const StlString & declFile,
                       unsigned int declLine,
                       const StlString & cstName,
                       ArConstRef<ArValue> value) // Private
: ArObject(arCW),
  _declCls(declCls),
  _declFile(declFile),
  _declLine(declLine),
  _cstName(cstName),
  _value(value)
{
ar_const_cast(_declCls)->_constants.push_back(thisRef());
setTransient(true);
}

ArConstant::~ArConstant(void) // Protected
{
for(unsigned int i=_declCls->_constants.size();i--;)
  {
  if(_declCls->_constants[i].c_ptr()==this)
    {
    StlVectorFastErase(ar_const_cast(_declCls)->_constants,i);
    break;
    }
  }
}

//-------- Inspection --------------------------------------------------------

ArConstRef<ArClass> // class declaring this constant
ArConstant::getDeclarationClass(void) const
{
return(_declCls);
}

const StlString & // declaration header file of this constant
ArConstant::getDeclarationFile(void) const
{
return(_declFile);
}

unsigned int // declaration line number of this constant
ArConstant::getDeclarationLine(void) const
{
return(_declLine);
}

const StlString & // name of this constant
ArConstant::getName(void) const
{
return(_cstName);
}

ArConstRef<ArValue> // value of this constant
ArConstant::getValue(void) const
{
return(_value);
}

} // namespace AReVi

//----------------------------------------------------------------------------
