// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventBase3D.cpp
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReViNS/Events/nsEventBase3D.h"
#include "AReVi/Utils/abstractStream.h"

namespace AReVi {
//----------------------------------------------------------------------------
// CLASS       : NSEventBase3DMotion
//----------------------------------------------------------------------------
AR_CLASS_DEF(NSEventBase3DMotion,NSEventRef)
//---------------------- Constructors / Destructor ---------------------------
NSEventBase3DMotion::NSEventBase3DMotion(ArCW & arCW) // Protected
  : NSEventRef(arCW), _base(false)
{
}

NSEventBase3DMotion::~NSEventBase3DMotion(void)
{
}

//---------------------------- Public methods --------------------------------
// Get Set Object3D attrib
const Util3D::Base &
NSEventBase3DMotion::getBase(void) const
{
  return _base;
}

void
NSEventBase3DMotion::setBase(const Util3D::Base &base)
{
  _base=base;
}

//-------------------------- Stream operations -------------------------------
bool // success
NSEventBase3DMotion::readFromStream(ArRef<AbstractIStream> input)
{
  if (!NSEventRef::readFromStream(input))
    return false;

  for (unsigned cpt=16;cpt--;)
    if (!input->readDouble(_base.matrix[cpt]))
      return false;
  return true;
}

void
NSEventBase3DMotion::writeToStream(ArRef<AbstractOStream> output) const
{
  NSEventRef::writeToStream(output);

  for (unsigned cpt=16;cpt--;)
    output->writeDouble(_base.matrix[cpt]);
}
} // namespace NetworkServices
//---End-Of-File---------------------------------------------------------------
