// LI2/ENIB - AReVi - Network services
//----------------------------------------------------------------------------
// file        : AReViNS/Events/nsEventShapePart3D.cpp
// author(s)   : E. Cazeaux
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

#include "AReViNS/Events/nsEventShapePart3D.h"
#include "AReVi/Utils/abstractStream.h"

namespace AReVi {
//----------------------------------------------------------------------------
// CLASS       : NSEventShapePart3DAppearanceRebuild
//----------------------------------------------------------------------------
AR_CLASS_DEF(NSEventShapePart3DAppearanceRebuild,NSEvent)
//---------------------- Constructors / Destructor ---------------------------
NSEventShapePart3DAppearanceRebuild::NSEventShapePart3DAppearanceRebuild(ArCW & arCW) // Protected
  : NSEvent(arCW),_offset(0.0)
{
}

NSEventShapePart3DAppearanceRebuild::~NSEventShapePart3DAppearanceRebuild(void)
{}

// Get/Set DepthOffset
void
NSEventShapePart3DAppearanceRebuild::setDepthOffset(double offset)
{
  _offset=offset;
}

double // depth buffer offset
NSEventShapePart3DAppearanceRebuild::getDepthOffset(void) const
{
  return _offset;
}

//-------------------------- Stream operations -------------------------------
void
NSEventShapePart3DAppearanceRebuild::writeToStream(ArRef<AbstractOStream> output) const
{
  NSEvent::writeToStream(output);

  output->writeDouble(_offset);
}

bool // success
NSEventShapePart3DAppearanceRebuild::readFromStream(ArRef<AbstractIStream> input)
{
  if (!NSEvent::readFromStream(input))
    return false;

  return input->readDouble(_offset);
}


//----------------------------------------------------------------------------
// CLASS       : NSEventShapePart3DGeometryRebuild
//----------------------------------------------------------------------------
AR_CLASS_DEF(NSEventShapePart3DGeometryRebuild,NSEvent)
//---------------------- Constructors / Destructor ---------------------------
NSEventShapePart3DGeometryRebuild::NSEventShapePart3DGeometryRebuild(ArCW & arCW) // Protected
  : NSEvent(arCW)
{
}

NSEventShapePart3DGeometryRebuild::~NSEventShapePart3DGeometryRebuild(void)
{
}

} // namespace NetworkServices
//---End-Of-File---------------------------------------------------------------
