// LI2/ENIB - AReVi - Java wrapper plugin
//----------------------------------------------------------------------------
// file        : Ext/JavaWrapper/AReViObject.java
// author(s)   : F. Harrouet
//----------------------------------------------------------------------------
// Copyright (C) 2002-2006  LI2/ENIB
//   Laboratoire d'Ingenierie Informatique (LI2)
//   Ecole Nationale d'Ingenieurs de Brest (ENIB)
//   CS 73862 - 29238 BREST Cedex 3 - France
//   Tel: +33(0)298 05 89 89, Fax: +33(0)298 05 89 79, e-mail: li2@enib.fr
//
// This software package is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
// This software package is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
// General Public License (file LICENSE-LGPL) for more details.
//----------------------------------------------------------------------------

import java.util.HashMap;

//----------------------------------------------------------------------------
// Class AReViObject
//----------------------------------------------------------------------------

public
class AReViObject
{
//-------- Construction / Destruction ----------------------------------------

protected
AReViObject(int address)
  {
  _address=address;
  synchronized(_instanceMap)
    {
    _instanceMap.put(new Integer(System.identityHashCode(this)),this);
    }
  }

protected
void
delete()
  {
  _address=0;
  synchronized(_instanceMap)
    {
    _instanceMap.remove(new Integer(System.identityHashCode(this)));
    }
  }

//-------- Identification ----------------------------------------------------

public final
int // AReVi address
getAReViAddress()
  {
  return(_address);
  }

public final
int // instance ID
getID()
  {
  return(System.identityHashCode(this));
  }

public static
AReViObject // found instance
findInstance(int instanceID)
  {
  synchronized(_instanceMap)
    {
    return((AReViObject)_instanceMap.get(new Integer(instanceID)));
    }
  }

/* very tricky and platform dependant ! do not use for now !
public native static
int // native window ID
windowID(java.awt.Component component);
*/

//-------- Communication -----------------------------------------------------

public
Object[] // result
fromAReVi(Object[] data)
  {
  System.err.println("Reading data for "+getClass().getName()+
                     "(0x"+Integer.toHexString(getAReViAddress())+")");
  for(int i=0;i<data.length;i++)
    {
    if(data[i] instanceof Boolean)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         (((Boolean)data[i]).booleanValue()
                          ? "true" : "false")+"]");
      }
    else if(data[i] instanceof Byte)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Byte)data[i]).byteValue()+"]");
      }
    else if(data[i] instanceof Character)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Character)data[i]).charValue()+"] (int:"+
                         (int)((Character)data[i]).charValue()+")");
      }
    else if(data[i] instanceof Short)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Short)data[i]).shortValue()+"]");
      }
    else if(data[i] instanceof Integer)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Integer)data[i]).intValue()+"]");
      }
    else if(data[i] instanceof Long)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Long)data[i]).longValue()+"]");
      }
    else if(data[i] instanceof Float)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Float)data[i]).floatValue()+"]");
      }
    else if(data[i] instanceof Double)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((Double)data[i]).doubleValue()+"]");
      }
    else if(data[i] instanceof String)
      {
      System.err.println("    "+data[i].getClass().getName()+" ["+
                         ((String)data[i])+"]");
      }
    }
  return((Object[])null);
  }

public native final
Object[] // result
toAReVi(Object[] data);

//-------- Initialization ----------------------------------------------------

public native static
boolean // go on
initApp(String[] args);

public native static
boolean // go on
updateApp();

public native static
void
destroyApp();

static
  {
  AReViObject._instanceMap=new HashMap();
  }

//-------- Member attributes -------------------------------------------------

private int _address;

//-------- Static attributes -------------------------------------------------

private static HashMap _instanceMap;
}

//----------------------------------------------------------------------------
